Attribute VB_Name = "Common"
Option Explicit

    Const MaxEventLogFilenameLen = 100000000 'max errorlog size = 100 megabytes
    
    Global Const GeneralSection = "General"
    Global Const VersionKey = "Version"
    Const ShowTooltipsKey = "ShowToolTips"
    
    
    Global Const MaxWPX = 8 'maximum width of a WPX prefix
    
    Global Const MASK_SHIFT = 1
    Global Const MASK_CONTROL = 2
    Global Const MASK_ALT = 4
    ' KeyCode (KeyDown, KeyUp)
    
    Global Const KEY_LBUTTON = &H1
    Global Const KEY_RBUTTON = &H2
    Global Const KEY_CANCEL = &H3
    Global Const KEY_MBUTTON = &H4         ' NOT contiguous with L & RBUTTON
    Global Const KEY_BACK = &H8
    Global Const KEY_TAB = &H9
    Global Const KEY_CLEAR = &HC
    Global Const KEY_RETURN = &HD
    Global Const KEY_SHIFT = &H10
    Global Const KEY_CONTROL = &H11
    Global Const KEY_MENU = &H12
    Global Const KEY_PAUSE = &H13
    Global Const KEY_CAPITAL = &H14
    Global Const KEY_ESCAPE = &H1B
    Global Const KEY_SPACE = &H20
    Global Const KEY_PRIOR = &H22
    Global Const KEY_NEXT = &H21
    Global Const KEY_END = &H23
    Global Const KEY_HOME = &H24
    Global Const KEY_LEFT = &H25
    Global Const KEY_UP = &H26
    Global Const KEY_RIGHT = &H27
    Global Const KEY_DOWN = &H28
    Global Const KEY_SELECT = &H29
    Global Const KEY_PRINT = &H2A
    Global Const KEY_EXECUTE = &H2B
    Global Const KEY_SNAPSHOT = &H2C
    Global Const KEY_INSERT = &H2D
    Global Const KEY_DELETE = &H2E
    Global Const KEY_HELP = &H2F
    
    ' KEY_A thru KEY_Z are the same as their ASCII equivalents: 'A' thru 'Z'
    ' KEY_0 thru KEY_9 are the same as their ASCII equivalents: '0' thru '9'
    
    Global Const KEY_NUMPAD0 = &H60
    Global Const KEY_NUMPAD1 = &H61
    Global Const KEY_NUMPAD2 = &H62
    Global Const KEY_NUMPAD3 = &H63
    Global Const KEY_NUMPAD4 = &H64
    Global Const KEY_NUMPAD5 = &H65
    Global Const KEY_NUMPAD6 = &H66
    Global Const KEY_NUMPAD7 = &H67
    Global Const KEY_NUMPAD8 = &H68
    Global Const KEY_NUMPAD9 = &H69
    Global Const KEY_MULTIPLY = &H6A
    Global Const KEY_ADD = &H6B
    Global Const KEY_SEPARATOR = &H6C
    Global Const KEY_SUBTRACT = &H6D
    Global Const KEY_DECIMAL = &H6E
    Global Const KEY_DIVIDE = &H6F
    Global Const KEY_F1 = &H70
    Global Const KEY_F2 = &H71
    Global Const KEY_F3 = &H72
    Global Const KEY_F4 = &H73
    Global Const KEY_F5 = &H74
    Global Const KEY_F6 = &H75
    Global Const KEY_F7 = &H76
    Global Const KEY_F8 = &H77
    Global Const KEY_F9 = &H78
    Global Const KEY_F10 = &H79
    Global Const KEY_F11 = &H7A
    Global Const KEY_F12 = &H7B
    Global Const KEY_F13 = &H7C
    Global Const KEY_F14 = &H7D
    Global Const KEY_F15 = &H7E
    Global Const KEY_F16 = &H7F
    Global Const KEY_NUMLOCK = &H90
    
    Global Const SlashZeroCode = 216
    
    Global Const WindowSection = "Windows"
    Global Const WindowLeftKey = "Left"
    Global Const WindowTopKey = "Top"
    Global Const WindowWidthKey = "Width"
    Global Const WindowHeightKey = "Height"
    Global Const WindowStateKey = "Windowstate"
    Global Const DualMonitorKey = "DualMonitor"

    Const DefaultPosition = 0
    Const DefaultTooltips = True
    
    ' ShowWindow() Commands
    Public Const SW_HIDE = 0                'Hides the window and activates another window.
    Public Const SW_SHOWNORMAL = 1          'Activates and displays a window. If the window is minimized or maximized, Windows restores it to its original size and position. An application should specify this flag when displaying the window for the first time.
    Public Const SW_SHOWMINIMIZED = 2       'Activates the window and displays it as a minimized window.
    Public Const SW_SHOWMAXIMIZED = 3       'Activates the window and displays it as a maximized window.
    Public Const SW_MAXIMIZE = 3            'Maximizes the specified window.
    Public Const SW_SHOWNOACTIVATE = 4      'Displays a window in its most recent size and position. The active window remains active.
    Public Const SW_SHOW = 5                'Activates the window and displays it in its current size and position.
    Public Const SW_MINIMIZE = 6            'Minimizes the specified window and activates the next top-level window in the Z order.
    Public Const SW_SHOWMINNOACTIVE = 7     'Displays the window as a minimized window. The active window remains active.
    Public Const SW_SHOWNA = 8              'Displays the window in its current state. The active window remains active.
    Public Const SW_RESTORE = 9             'Activates and displays the window. If the window is minimized or maximized, Windows restores it to its original size and position. An application should specify this flag when restoring a minimized window.
    Public Const SW_SHOWDEFAULT = 10        'Sets the show state based on the SW_ flag specified in the STARTUPINFO structure passed to the CreateProcess function by the program that started the application.
    

    'made global 2012-06-17
    Global Const ERROR_BAD_FORMAT = 11&
    Global Const ERROR_FILE_NOT_FOUND = 2&
    Global Const ERROR_PATH_NOT_FOUND = 3&          ' The specified path was not found. '
    Global Const SE_ERR_ACCESSDENIED = 5            ' The operating system denied access to the specified file. '
    Global Const SE_ERR_ASSOCINCOMPLETE = 27        ' The file name association is incomplete or invalid. '
    Global Const SE_ERR_DDEBUSY = 30                ' The Dynamic Data Exchange (DDE) transaction could not be completed because other DDE transactions were being processed. '
    Global Const SE_ERR_DDEFAIL = 29                ' The DDE transaction failed. '
    Global Const SE_ERR_DDETIMEOUT = 28             ' The DDE transaction could not be completed because the request timed out. '
    Global Const SE_ERR_DLLNOTFOUND = 32            ' The specified dynamic-link library (DLL) was not found. '
    Global Const SE_ERR_FNF = 2                     ' The specified file was not found. '
    Global Const SE_ERR_NOASSOC = 31                ' There is no application associated with the given file name extension. '
    Global Const SE_ERR_OOM = 8                     '  out of memory '
    Global Const SE_ERR_PNF = 3                     '  path not found '
    Global Const SE_ERR_SHARE = 26                  ' A sharing violation occurred. '

    Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

    Public Declare Function GetDesktopWindow Lib "user32" () As Long
    Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
    Public Declare Function GetVersionExA Lib "kernel32" (lpVersionInformation As OSVERSIONINFO) As Integer
    
    Public Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
    
    Public Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
    Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long

    Public Const PROCESS_TERMINATE = 1

    
    Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
    End Type
    
    Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
    End Type
    
    Public Type POINTAPI
        X As Long
        Y As Long
    End Type
    
    Public Type WINDOWPLACEMENT
        Length As Long
        Flags  As Long
        showCmd As Long
        ptMinPosition As POINTAPI
        ptMaxPosition As POINTAPI
        rcNormalPosition As RECT
    End Type
    
    Public Declare Function BringWindowToTop Lib "user32" (ByVal hwnd As Long) As Long
    Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
    Public Declare Function GetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
    Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
    Public Declare Function SetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
    Public Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
    
    Public Const HWND_TOPMOST = -1
    Public Const HWND_NOTOPMOST = -2
    Public Const SWP_NOMOVE = &H2
    Public Const SWP_NOSIZE = &H1
    Public Const TOPMOST_FLAGS = SWP_NOMOVE Or SWP_NOSIZE

    Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, Y, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

    Public Const URLDownloadToFile_SUCCESS As Long = 0
    Public Const E_OUTOFMEMORY = &H8007000E
    Public Const E_ACCESSDENIED = &H80070005
    
    Public Const INET_E_INVALID_URL = &H800C0002
    Public Const INET_E_NO_SESSION = &H800C0003
    Public Const INET_E_CANNOT_CONNECT = &H800C0004
    Public Const INET_E_RESOURCE_NOT_FOUND = &H800C0005
    Public Const INET_E_OBJECT_NOT_FOUND = &H800C0006
    Public Const INET_E_DATA_NOT_AVAILABLE = &H800C0007
    Public Const INET_E_DOWNLOAD_FAILURE = &H800C0008
    Public Const INET_E_AUTHENTICATION_REQUIRED = &H800C0009
    Public Const INET_E_NO_VALID_MEDIA = &H800C000A
    Public Const INET_E_CONNECTION_TIMEOUT = &H800C000B
    Public Const INET_E_INVALID_REQUEST = &H800C000C
    Public Const INET_E_UNKNOWN_PROTOCOL = &H800C000D
    Public Const INET_E_SECURITY_PROBLEM = &H800C000E
    Public Const INET_E_CANNOT_LOAD_DATA = &H800C000F
    Public Const INET_E_CANNOT_INSTANTIATE_OBJECT = &H800C0010
    Public Const INET_E_QUERYOPTION_UNKNOWN = &H800C0013
    Public Const INET_E_REDIRECT_FAILED = &H800C0014
    Public Const INET_E_REDIRECT_TO_DIR = &H800C0015
    Public Const INET_E_CANNOT_LOCK_REQUEST = &H800C0016

    Private Const BINDF_GETNEWESTVERSION As Long = &H10
    Private Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Long, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Long, ByVal lpfnCB As Long) As Long

    Declare Function DeleteUrlCacheEntry Lib "wininet.dll" Alias "DeleteUrlCacheEntryA" (ByVal lpszUrlName As String) As Long
    
    Private Declare Function GlobalMemoryStatusEx Lib "Kernel32.dll" (ByRef lpBuffer As MemoryStatusEx) As Long
    
    Private Type MemoryStatusEx
        dwLength As Long
        dwMemoryLoad As Long
        ullTotalPhys As Currency
        ullAvailPhys As Currency
        ullTotalPageFile As Currency
        ullAvailPageFile As Currency
        ullTotalVirtual As Currency
        ullAvailVirtual As Currency
        ullAvailExtendedVirtual As Currency
    End Type

    Private Type SYSTEM_INFO
        wProcessorArchitecture        As Integer
        wReserved                     As Integer
        dwPageSize                    As Long
        lpMinimumApplicationAddress   As Long
        lpMaximumApplicationAddress   As Long
        dwActiveProcessorMask         As Long
        dwNumberOfProcessors          As Long
        dwProcessorType               As Long
        dwAllocationGranularity       As Long
        wProcessorLevel               As Integer
        wProcessorRevision            As Integer
    End Type
    
    'Constants for GetSystemInfo and GetNativeSystemInfo API functions (SYSTEM_INFO structure)
    Private Const PROCESSOR_ARCHITECTURE_AMD64 As Long = 9      'x64 (AMD or Intel)
    Private Const PROCESSOR_ARCHITECTURE_IA64  As Long = 6      'Intel Itanium Processor Family (IPF)
    Private Const PROCESSOR_ARCHITECTURE_INTEL As Long = 0      'x86
    Private Const PROCESSOR_ARCHITECTURE_UNKNOWN As Long = &HFFFF&  'Unknown architecture
    
    Private Const PROCESSOR_INTEL_386  As Long = 386
    Private Const PROCESSOR_INTEL_486  As Long = 486
    Private Const PROCESSOR_INTEL_PENTIUM  As Long = 586
    Private Const PROCESSOR_INTEL_IA64  As Long = 2200
    Private Const PROCESSOR_AMD_X8664  As Long = 8664
    
    Private Declare Sub GetNativeSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEM_INFO)

    Type VersionInfo
        Version As String
        Major As Integer
        Minor As Integer
        Revision As Integer
    End Type
    
    '2015-12-02 made global/public for SC 7.4.8 2016-02-12
    Global Const LOGPIXELSX As Long = 88
    Global Const LOGPIXELSY As Long = 90
    Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
    
    Public Declare Function EnumDisplayMonitors Lib "user32" (ByVal hDC As Long, lprcClip As Any, ByVal lpfnEnum As Long, dwData As Any) As Long
    Public Declare Function MonitorFromRect Lib "user32" (ByRef lprc As RECT, ByVal dwFlags As Long) As Long
    Public Declare Function GetMonitorInfo Lib "user32" Alias "GetMonitorInfoA" (ByVal hMonitor As Long, ByRef lpmi As MONITORINFO) As Long
    Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
    Public Declare Function UnionRect Lib "user32" (lprcDst As RECT, lprcSrc1 As RECT, lprcSrc2 As RECT) As Long
    Public Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
    Public Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
        
    Type MONITORINFO
        cbSize As Long
        rcMonitor As RECT
        rcWork As RECT
        dwFlags As Long
    End Type

    Public Const MONITOR_DEFAULTTONULL = &H0
    Public Const MONITOR_DEFAULTTOPRIMARY = &H1
    Public Const MONITOR_DEFAULTTONEAREST = &H2
    
    Dim rcMonitors() As RECT 'coordinate array for all monitors
    Dim rcVS         As RECT 'coordinates for Virtual Screen
    
    Global Const FirstGridListMember = 0
    Global Const LastGridListMember = 3
    Global Const GridListMembers = LastGridListMember + 1

    Dim EventLogFilename As String
    Dim EventLogExists As Boolean
    
    Dim StartTime As Date
    Dim StartupLogged As Boolean

    Dim DebugEnabled As Boolean
    
    Dim ToolTips() As String
    Dim FormCount As Integer
    Dim Controls() As Integer
    Dim MaxControls As Integer
    
    Dim ScreenWidth As Long
    Dim ScreenHeight As Long
    Dim DualMonitor As Boolean
    
    Dim BrowserPathname As String
    
    Dim MonthArray(1 To 12) As String
       
    Dim OsVersionPlatform As Long
    Dim OsVersionMajor As Long
    Dim OsVersionMinor As Long
    Dim OsVersionBuild As Long
    Dim OsVersionName As String
    Dim OSShortVersionName As String '2015-12-02
    
    Dim OSWordLength As Integer
    
    Dim ErrorLogExistsFlag As Boolean
    
    Dim MemoryUsageCheckpoint As MemoryStatusEx
    
    Dim UnicodeFont As String
    Dim DefaultFont As String
    
    Dim theLogFile As Integer
    
    Type RestorePoint
        X As Integer
        Y As Integer
    End Type
    
    Dim RestoreX As Integer
    Dim RestoreY As Integer
    

Sub Initialize()

    StartupLogged = False
    
    DebugEnabled = False
    
    ErrorLogExistsFlag = False
    
    UnicodeFont = ""
    DefaultFont = ""
    
    OsVersionName = "Unknown"
    EventLogFilename = App.Path + "\ErrorLog.txt"
    EventLogExists = (Len(Dir(EventLogFilename)) > 0) '2012-12-06
    
    On Error GoTo Abort
    
    StartTime = UTC.CurrentTime
    
    Common.GetOSVersion
    
    ScreenWidth = Screen.Width
    ScreenHeight = Screen.Height
    
    DualMonitor = Common.GetBooleanSetting(App.ProductName, WindowSection, DualMonitorKey, Format$(False))
    
    SaveSetting App.ProductName, GeneralSection, VersionKey, Format(App.Major, "0") + Format(App.Minor, "0") + Format(App.Revision, "0") '2015-01-13
    
    BrowserPathname = ""
    
    RestoreX = 0
    RestoreY = 0
    
    Common.InitializeMonths
    
    Exit Sub
    
Abort:
    Common.ProgramError Err.Number, "Common.Initialize"
End Sub

Sub Terminate()
    On Error GoTo Abort

    If StartupLogged Then
        Log ("Common.Terminate: " + App.ProductName + " shutdown")
    End If
    
    '2015-11-19
    On Error Resume Next
    Unload CommonUI
    
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.Terminate"

End Sub

Function GetErrorLogExists()
    On Error GoTo Abort

    GetErrorLogExists = ErrorLogExistsFlag
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetErrorLogExists"

End Function

Sub SetErrorLogExists(theValue)
    On Error GoTo Abort

    ErrorLogExistsFlag = theValue
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.SetErrorLogExists"

End Sub

Sub SetErrorLogPathname(thePath As String)

    On Error GoTo Abort
    EventLogFilename = thePath
    Exit Sub
    
Abort: Common.ProgramError Err.Number, "Common.SetErrorLogPathname"

End Sub

Function GetErrorLogPathname() As String

    On Error GoTo Abort
    GetErrorLogPathname = EventLogFilename
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.GetErrorLogPathname"

End Function

Sub SetDebug(Enabled As Boolean)
    On Error GoTo Abort

    DebugEnabled = Enabled
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.SetDebug"

End Sub

Function GetDebug() As Boolean
    On Error GoTo Abort

    GetDebug = DebugEnabled
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetDebug"
    GetDebug = True
    
End Function

Sub DebugLog(theItem As String)
    On Error GoTo Abort

    'Debug.Print theItem
    
    If DebugEnabled Then
        Common.Log theItem
    End If
    
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.DebugLog"

End Sub

Function CSDVersionTrim(theCSDVersion As String) As String

    Dim I As Integer
    Dim theVersion As String
    Dim theChar As String
    Dim Result As String
    
    On Error GoTo Abort
    
    theVersion = Trim$(theCSDVersion)
    CSDVersionTrim = ""
    
    If Len(theCSDVersion) = 0 Then Exit Function
    
    Result = ""
    For I = 1 To Len(theVersion)
        theChar = Mid$(theVersion, I, 1)
        If Asc(theChar) = 0 Then Exit For
        Result = Result + theChar
    Next I
    
    CSDVersionTrim = Result
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.CSDVersionTrim"

End Function

Sub GetOSVersion()
    Dim OSInfo As OSVERSIONINFO
    Dim SysInfo As SYSTEM_INFO
    
    Dim Result As Integer
    
    Dim CouldBe64Bit As Boolean
    Dim WordLength As String
    
    Dim OsCSDVersion As String
    Dim TrimmedCSDVersion As String
    
    Dim I As Integer
    
    On Error GoTo Abort
    
    Common.DebugLog "Common.GetOSVersion"
    
    OSInfo.dwOSVersionInfoSize = 148
    OSInfo.szCSDVersion = Space$(128)
    Result = GetVersionExA(OSInfo)

    OsVersionPlatform = OSInfo.dwPlatformId
    OsVersionMajor = OSInfo.dwMajorVersion
    OsVersionMinor = OSInfo.dwMinorVersion
    OsVersionBuild = OSInfo.dwBuildNumber
    OsCSDVersion = OSInfo.szCSDVersion
    
    OsVersionName = "unknown (" + Format$(OSInfo.dwPlatformId) + "." + Format$(OSInfo.dwMajorVersion) + "." + Format$(OSInfo.dwMinorVersion) + ")"
    OSShortVersionName = OsVersionName '2015-12-02
    
    CouldBe64Bit = False
    OSWordLength = 16
    
    Select Case OSInfo.dwPlatformId

        Case 0
            OsVersionName = "Windows 3.1"
        
        Case 1 'VER_PLATFORM_WIN32_WINDOWS
            
            Select Case OSInfo.dwMinorVersion
                Case 0
                    OsVersionName = "Windows 95"
                Case 10
                    OsVersionName = "Windows 98"
                Case 90
                    OsVersionName = "Windows Millennium"
            End Select
            
            OSShortVersionName = OsVersionName '2015-12-02
            
    
        Case 2 'VER_PLATFORM_WIN32_NT
            
            Select Case OSInfo.dwMajorVersion
                Case 3
                    OsVersionName = "Windows NT 3.51"
                    OSShortVersionName = OsVersionName '2015-12-02
                    OSWordLength = 32
                    
                Case 4
                    OsVersionName = "Windows NT 4.0"
                    OSShortVersionName = OsVersionName '2015-12-02
                    OSWordLength = 32
                    
                Case 5
                    Select Case OSInfo.dwMinorVersion
                        Case 0
                            OsVersionName = "Windows 2000"
                            OSShortVersionName = OsVersionName '2015-12-02
                            OSWordLength = 32
                        
                        Case 1
                            OsVersionName = "Windows XP"
                            OSShortVersionName = OsVersionName '2015-12-02
                            CouldBe64Bit = True
                            
                        Case 2
                            OsVersionName = "Windows Server"
                            OSShortVersionName = OsVersionName '2015-12-02
                            OSWordLength = 32
                            
                    End Select
                    
                Case 6
                    
                    Select Case OSInfo.dwMinorVersion
                        Case 0
                            OsVersionName = "Vista"
                            OSShortVersionName = OsVersionName '2015-12-02
                            CouldBe64Bit = True
                            
                        '2015-11-19 use registry values to distinguish between Windows 8.1 and Windows 10
                        
                        'Case 1
                        '    OsVersionName = "Windows 7"
                        '    CouldBe64Bit = True
                            
                        'Case 2
                        '    OsVersionName = "Windows 8" '2014-01-09
                        '    CouldBe64Bit = True
                            
                        'Case 3
                        '    OsVersionName = "Windows 8.1" '2014-01-09
                        '    CouldBe64Bit = True
                            
                            
                        Case Else
                            
                            CouldBe64Bit = True
                            
                            OsVersionBuild = 0
                            If Registry.KeyValuePresent(HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows NT\CurrentVersion", "CurrentBuildNumber") Then
                                On Error Resume Next
                                OsVersionBuild = CLng(Registry.GetKeyValue(HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows NT\CurrentVersion", "CurrentBuildNumber"))
                                On Error GoTo Abort
                            End If
                                                                
                            If Registry.KeyValuePresent(HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows NT\CurrentVersion", "ProductName") Then
                                OsVersionName = Registry.GetKeyValue(HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows NT\CurrentVersion", "ProductName")
                                
                                If InStr(OsVersionName, "Windows ") = 1 Then '2015-12-02
                                    OSShortVersionName = "Windows "
                                    For I = 9 To Len(OsVersionName)
                                        If Mid$(OsVersionName, I, 1) <> " " Then
                                            OSShortVersionName = OSShortVersionName + Mid$(OsVersionName, I, 1)
                                        Else
                                            Exit For
                                        End If
                                    Next I
                                End If
                                
                                If Len(Trim$(OsCSDVersion)) > 0 Then
                                    TrimmedCSDVersion = Common.CSDVersionTrim(OsCSDVersion)
                                    If Len(TrimmedCSDVersion) > 0 Then
                                        OsVersionName = OsVersionName + " [" + TrimmedCSDVersion + "]"
                                    End If
                                End If
                                    
                            Else
                               'if no ProductName in registry, attempt to determine OsVersion name from minor version #
                                Select Case OSInfo.dwMinorVersion
                                
                                    Case 1
                                        OsVersionName = "Windows 7"
                                        
                                    Case 2
                                        OsVersionName = "Windows 8"
                                        
                                    Case 3
                                        If OsVersionBuild = 0 Then
                                            OsVersionName = "?"
                                            
                                        ElseIf OsVersionBuild < 10000 Then
                                            OsVersionName = "Windows 8.1"
        
                                        Else
                                            OsVersionName = "Windows 10"
                                        End If
                                    
                                End Select
                                
                                OSShortVersionName = OsVersionName '2015-12-02
                                    
                            End If
                                                       
                    End Select
                    
            End Select
    End Select

    If CouldBe64Bit Then
    
        Call GetNativeSystemInfo(SysInfo)
       
        Select Case SysInfo.wProcessorArchitecture
        
            Case PROCESSOR_ARCHITECTURE_AMD64, PROCESSOR_ARCHITECTURE_IA64
                
                OSWordLength = 64
                
            Case Else
            
                OSWordLength = 32
                
        End Select
        
    End If
        
    Exit Sub
    
Abort:
    Common.ProgramError Err.Number, "Common.GetOSVersion"
End Sub

Function GetOSPlatform() As Long
    On Error GoTo Abort

    GetOSPlatform = OsVersionPlatform
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetOSPlatform"

End Function

Function GetOSMajorVersion() As Long
    On Error GoTo Abort

    GetOSMajorVersion = OsVersionMajor
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetOSMajorVersion"

End Function

Function GetOSMinorVersion() As Long
    On Error GoTo Abort

    GetOSMinorVersion = OsVersionMinor
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetOSMinorVersion"

End Function

Function GetOSBuild() As Long
    On Error GoTo Abort

    GetOSBuild = OsVersionBuild
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetOSBuild"

End Function

Function GetOSName() As String
    On Error GoTo Abort

    GetOSName = OsVersionName
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetOSName"

End Function

Function GetShortOSName() As String
    On Error GoTo Abort

    GetShortOSName = OSShortVersionName
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.ShortOSName"

End Function

Function GetOSWordLength() As Integer
    On Error GoTo Abort

    GetOSWordLength = OSWordLength
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetOSWordLength"

End Function

Sub InitializeMonths()
    On Error GoTo Abort
    
    MonthArray(1) = "Jan"
    MonthArray(2) = "Feb"
    MonthArray(3) = "Mar"
    MonthArray(4) = "Apr"
    MonthArray(5) = "May"
    MonthArray(6) = "Jun"
    MonthArray(7) = "Jul"
    MonthArray(8) = "Aug"
    MonthArray(9) = "Sep"
    MonthArray(10) = "Oct"
    MonthArray(11) = "Nov"
    MonthArray(12) = "Dec"
    Exit Sub
    
Abort:
    Common.ProgramError Err.Number, "Common.InitializeMonths"
End Sub

Function MonthName(Index As Integer) As String
    On Error GoTo Abort

    MonthName = MonthArray(Index)
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.MonthName"

End Function

Function ISODate(theDate As Date) As String
    Dim theYear As String
    Dim theMonth As String
    Dim theDay As String
    
    On Error GoTo Abort

    theYear = Year(theDate)
    
    theMonth = Month(theDate)
    If Len(theMonth) = 1 Then theMonth = "0" + theMonth
    
    theDay = Day(theDate)
    If Len(theDay) = 1 Then theDay = "0" + theDay
    
    ISODate = theYear + "-" + theMonth + "-" + theDay
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.ISODate"

End Function

Function ISODateTime(theDate As Date) As String
    Dim theYear As String
    Dim theMonth As String
    Dim theDay As String
    Dim theHour As String
    Dim theMinute As String
    Dim theSecond As String
    
    On Error GoTo Abort

    theYear = Year(theDate)
    
    theMonth = Month(theDate)
    If Len(theMonth) = 1 Then theMonth = "0" + theMonth
    
    theDay = Day(theDate)
    If Len(theDay) = 1 Then theDay = "0" + theDay
    
    theHour = Hour(theDate)
    If Len(theHour) = 1 Then theHour = "0" + theHour
    
    theMinute = Minute(theDate)
    If Len(theMinute) = 1 Then theMinute = "0" + theMinute
    
    theSecond = Second(theDate)
    If Len(theSecond) = 1 Then theSecond = "0" + theSecond
    
    ISODateTime = theYear + "-" + theMonth + "-" + theDay + " " + theHour + ":" + theMinute + ":" + theSecond
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.ISODateTime"

End Function

Function EnumMonitors(F As Form) As Long
    
    Dim MonitorCount As Long
    
    On Error Resume Next
    EnumDisplayMonitors 0, ByVal 0&, AddressOf MonitorEnumProc, MonitorCount
    
    Print #theLogFile, Format$(UTC.CurrentTime, "dd-mmm-yyyy hh:nn:ss"); " > " + "Monitors          : " + Format$(MonitorCount)
        
    For MonitorCount = 0 To MonitorCount - 1
        
        Print #theLogFile, Format$(UTC.CurrentTime, "dd-mmm-yyyy hh:nn:ss"); " > " + "Monitor " + Format$(MonitorCount + 1)
        Print #theLogFile, Format$(UTC.CurrentTime, "dd-mmm-yyyy hh:nn:ss"); " > " + "   width          : " + Format$(rcMonitors(MonitorCount).Right - rcMonitors(MonitorCount).Left)
        Print #theLogFile, Format$(UTC.CurrentTime, "dd-mmm-yyyy hh:nn:ss"); " > " + "   height         : " + Format$(rcMonitors(MonitorCount).Bottom - rcMonitors(MonitorCount).Top)
        Print #theLogFile, Format$(UTC.CurrentTime, "dd-mmm-yyyy hh:nn:ss"); " > " + "   dimensions     : " + "(" + Format$(rcMonitors(MonitorCount).Left) + ", " + Format$(rcMonitors(MonitorCount).Top) + ")-(" + Format$(rcMonitors(MonitorCount).Right) + ", " + Format$(rcMonitors(MonitorCount).Bottom) + ")"
    Next MonitorCount
    
End Function

Private Function MonitorEnumProc(ByVal hMonitor As Long, ByVal hdcMonitor As Long, lprcMonitor As RECT, dwData As Long) As Long

    ReDim Preserve rcMonitors(dwData)
    
    rcMonitors(dwData) = lprcMonitor
    
    UnionRect rcVS, rcVS, lprcMonitor 'merge all monitors together to get the virtual screen coordinates
    dwData = dwData + 1 'increase monitor count
    MonitorEnumProc = 1 'continue

End Function

Sub SetDualMonitor(Enabled As Boolean)
    
    On Error GoTo Abort

    DualMonitor = Enabled
    SaveSetting App.ProductName, WindowSection, DualMonitorKey, Format$(DualMonitor)
    
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.SetDualMonitor"

End Sub

Function GetDualMonitor() As Boolean
    On Error GoTo Abort

    GetDualMonitor = DualMonitor
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetDualMonitor"

End Function

Function ReasonableLeft(Position As Long) As Long
    On Error GoTo Abort

    If DualMonitor Or ((Position >= 0) And (Position <= (0.95 * Screen.Width))) Then
        ReasonableLeft = Position
    Else
        ReasonableLeft = 0
    End If
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.ReasonableLeft"

End Function

Function ReasonableTop(Position As Long) As Long
    On Error GoTo Abort

    If DualMonitor Or ((Position >= 0) And (Position <= (0.95 * Screen.Height))) Then
        ReasonableTop = Position
    Else
        ReasonableTop = 0
    End If
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.ReasonableTop"

End Function

Function ReasonableWidth(theWidth As Long) As Long
    On Error GoTo Abort

    If (theWidth < 0) Then
        ReasonableWidth = 0.5 * Screen.Width
    
    ElseIf (Not DualMonitor) And (theWidth > (1.1 * Screen.Width)) Then
        ReasonableWidth = 0.5 * Screen.Width
        
    Else
        ReasonableWidth = theWidth
    
    End If
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.ReasonableWidth"

End Function

Function ReasonableHeight(theHeight As Long) As Long
    On Error GoTo Abort

    If (theHeight < 0) Then
        ReasonableHeight = 0.5 * Screen.Height
    
    ElseIf (Not DualMonitor) And (theHeight > (1.1 * Screen.Height)) Then
        ReasonableHeight = 0.5 * Screen.Height
        
    Else
        ReasonableHeight = theHeight
    
    End If
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.ReasonableHeight"

End Function

Function GetRestorePoint() As RestorePoint
    
    '2016.02.12 for SC 7.4.7
    
    On Error GoTo Abort
    GetRestorePoint.X = RestoreX
    GetRestorePoint.Y = RestoreY
    RestoreX = RestoreX + 360 'twips => .25 inches
    RestoreY = RestoreY + 360 'twips => .25 inches
    
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetRestorePoint"
    
End Function

Sub RestoreWindowPosition(FormInstance As Form)

    On Error GoTo Abort

    Dim OriginalLeft As Long
    Dim OriginalTop As Long
    Dim OriginalWidth As Long
    Dim OriginalHeight As Long
    
    Dim TwipsPerPixel As Single
    
    Dim theRect As RECT
    Dim ActRect As RECT
    Dim hMonitor As Long
    
    Dim DPIX As Integer
    Dim DPIY As Integer
    
    FormInstance.WindowState = vbNormal
    
    OriginalLeft = Common.GetLongSetting(App.ProductName, WindowSection, FormInstance.Name + WindowLeftKey, Format$(FormInstance.Left))
    OriginalTop = Common.GetLongSetting(App.ProductName, WindowSection, FormInstance.Name + WindowTopKey, Format$(FormInstance.Top))
    
    OriginalWidth = Common.GetLongSetting(App.ProductName, WindowSection, FormInstance.Name + WindowWidthKey, Format$(FormInstance.Width))
    OriginalHeight = Common.GetLongSetting(App.ProductName, WindowSection, FormInstance.Name + WindowHeightKey, Format$(FormInstance.Height))
    
    If DualMonitor Then '2015.11.09
    
        GetWindowRect FormInstance.hwnd, theRect 'obtain the window rectangle (pixels)
        
        '2015-12-02
        'DPIX = CInt(((theRect.Right - theRect.Left) * 1440) / OriginalWidth)
        'DPIY = CInt(((theRect.Bottom - theRect.Top) * 1440) / OriginalHeight)
        
        DPIX = GetDeviceCaps(FormInstance.hDC, LOGPIXELSX)
        DPIY = GetDeviceCaps(FormInstance.hDC, LOGPIXELSY)
        
        ActRect.Left = (OriginalLeft / 1440) * DPIX
        ActRect.Right = ((OriginalLeft + OriginalWidth) / 1440) * DPIX
        ActRect.Top = (OriginalTop / 1440) * DPIY
        ActRect.Bottom = ((OriginalTop + OriginalHeight) / 1440) * DPIY
    
        hMonitor = MonitorFromRect(ActRect, MONITOR_DEFAULTTONULL)
        
        If hMonitor = 0 Then
            RestoreX = RestoreX + 360 'twips => .25 inches
            FormInstance.Left = RestoreX
            
            RestoreY = RestoreY + 360 'twips => .25 inches
            FormInstance.Top = RestoreY
        Else
            FormInstance.Left = OriginalLeft
            FormInstance.Top = OriginalTop
        End If
        
    Else
    
        FormInstance.Left = ReasonableLeft(OriginalLeft)
        FormInstance.Top = ReasonableTop(OriginalTop)
    
    End If
    
    If (FormInstance.BorderStyle = vbSizable) Or (FormInstance.BorderStyle = vbSizableToolWindow) Then
        FormInstance.Width = ReasonableWidth(OriginalWidth)
        FormInstance.Height = ReasonableHeight(OriginalHeight)
    End If
    
    FormInstance.WindowState = Common.GetIntegerSetting(App.ProductName, WindowSection, FormInstance.Name + WindowStateKey, Format$(FormInstance.WindowState))

    Common.DebugLog "Common.RestoreWindowPosition: " + FormInstance.Name + ", DualMonitor = " + Format$(DualMonitor)
    Common.DebugLog "   from registry = (" + Format$(OriginalLeft) + ", " + Format$(OriginalTop) + ", " + Format$(OriginalWidth) + ", " + Format$(OriginalHeight) + ")"
    Common.DebugLog "   restored to   = (" + Format$(FormInstance.Left) + ", " + Format$(FormInstance.Top) + ", " + Format$(FormInstance.Width) + ", " + Format$(FormInstance.Height) + ")"
    Common.DebugLog "   WindowState   = " + Format$(FormInstance.WindowState)

    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.RestoreWindowPosition"

End Sub

Sub SaveWindowPosition(FormInstance As Form)

    Dim OriginalWindowState As Integer
    Dim SleepCount As Integer
    
    On Error GoTo Abort
    
    OriginalWindowState = FormInstance.WindowState
    SaveSetting App.ProductName, WindowSection, FormInstance.Name + "WindowState", Format$(FormInstance.WindowState)
    
    If FormInstance.WindowState <> vbNormal Then  '5/17/2005
        FormInstance.WindowState = vbNormal
        DoEvents  'let new size settle before saving to registry
        
        '2010-11-13
        If Not FormInstance.Visible Then
            SleepCount = 10
        
            Do
                Sleep 1
                DoEvents
                SleepCount = SleepCount - 1
                If SleepCount <= 0 Then Exit Do
                If FormInstance.Visible Then Exit Do
            Loop
            
        End If
        
    End If
     
    SaveSetting App.ProductName, WindowSection, FormInstance.Name + WindowLeftKey, Format$(FormInstance.Left)
    SaveSetting App.ProductName, WindowSection, FormInstance.Name + WindowTopKey, Format$(FormInstance.Top)
    SaveSetting App.ProductName, WindowSection, FormInstance.Name + WindowHeightKey, Format$(FormInstance.Height)
    SaveSetting App.ProductName, WindowSection, FormInstance.Name + WindowWidthKey, Format$(FormInstance.Width)
     
    FormInstance.WindowState = OriginalWindowState
    
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.SaveWindowPosition"

End Sub

Function InitializeTooltips() As Boolean
    Dim I As Integer

    On Error GoTo Abort

    FormCount = Forms.Count
    ReDim Controls(0 To FormCount - 1)
    
    MaxControls = 0
    For I = 0 To FormCount - 1
        Controls(I) = Forms(I).Controls.Count '#controls on form
        If MaxControls < Controls(I) Then
            MaxControls = Controls(I)
        End If
    Next I
    
    ReDim ToolTips(0 To FormCount - 1, 0 To MaxControls - 1)
    
    SaveTooltips
    
    InitializeTooltips = Common.GetBooleanSetting(App.ProductName, GeneralSection, ShowTooltipsKey, DefaultTooltips)

    Exit Function

Abort: Common.ProgramError Err.Number, "Common.InitializeTooltips"

End Function

Sub SaveTooltipSetting(theValue As Boolean)
    On Error GoTo Abort

    SaveSetting App.ProductName, GeneralSection, ShowTooltipsKey, Format$(theValue)
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.SaveTooltipSetting"

End Sub

Sub SaveTooltips()
    Dim I As Integer
    Dim J As Integer
    
    On Error GoTo Abort

    On Error Resume Next 'handle controls that don't support tooltips
    
    For I = 0 To FormCount - 1
        For J = 0 To Controls(I) - 1
            ToolTips(I, J) = Forms(I).Controls(J).ToolTipText
        Next J
    Next I

    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.SaveTooltips"

End Sub

Sub HideTooltips()
    Dim I As Integer
    Dim J As Integer
    
    On Error Resume Next 'handle controls that don't support tooltips
    
    For I = 0 To FormCount - 1
        For J = 0 To Controls(I) - 1
            Forms(I).Controls(J).ToolTipText = ""
        Next J
    Next I

    Exit Sub

End Sub

Sub RestoreToolTips()
    Dim I As Integer
    Dim J As Integer
    
    On Error Resume Next 'handle controls that don't support tooltips
    
    For I = 0 To FormCount - 1
        For J = 0 To Controls(I) - 1
            Forms(I).Controls(J).ToolTipText = ToolTips(I, J)
        Next J
    Next I
    
End Sub

Sub SetBrowserPathname(thePath As String)
    On Error GoTo Abort

    Common.DebugLog "Common.SetBrowserPathname, thePath = " + thePath
    BrowserPathname = thePath
    Exit Sub

Abort:

    Common.ProgramError Err.Number, "Common.SetBrowserPathname"

End Sub

Public Sub RunShellExecute(sTopic As String, sFile As Variant, sParams As Variant, sDirectory As Variant, nShowCmd As Long)
    
    'calling with sTopic set to "runas" will "run as administrator"
    Dim HwndDesk As Long
    Dim Success As Long

    On Error GoTo Abort
    
    HwndDesk = GetDesktopWindow()
  
    Success = ShellExecute(HwndDesk, sTopic, sFile, sParams, sDirectory, nShowCmd)
   
    If Success = SE_ERR_NOASSOC Then
        Call Shell("rundll32.exe shell32.dll,OpenAs_RunDLL " & sFile, vbNormalFocus)
    End If
    Exit Sub

Abort:

    ProgramError Err.Number, "Common.RunShellExecute"

End Sub

Public Function RunShellExecuteStatus(sTopic As String, sFile As Variant, sParams As Variant, sDirectory As Variant, nShowCmd As Long) As Long

    'calling with sTopic set to "runas" will "run as administrator"
    Dim HwndDesk As Long
    Dim Success As Long

    On Error GoTo Abort
    
    HwndDesk = GetDesktopWindow()
  
    Success = ShellExecute(HwndDesk, sTopic, sFile, sParams, sDirectory, nShowCmd)
   
    If Success = SE_ERR_NOASSOC Then
        Success = Shell("rundll32.exe shell32.dll,OpenAs_RunDLL " & sFile, vbNormalFocus)
    End If
    
    RunShellExecuteStatus = Success
    
    Exit Function

Abort:

    ProgramError Err.Number, "Common.RunShellExecuteStatus"

End Function

Function TerminateWindowProcess(WindowName As String) As Boolean

    Dim theWindowHandle As Long
    Dim theProcessID As Long
    Dim theProcess As Long
    
    On Error GoTo Abort
    
    TerminateWindowProcess = False
    
    theWindowHandle = FindWindow(vbNullString, WindowName)
    If theWindowHandle <> 0 Then
        GetWindowThreadProcessId theWindowHandle, theProcessID
        theProcess = OpenProcess(PROCESS_TERMINATE, True, theProcessID)
        TerminateProcess theProcess, 0
        
        TerminateWindowProcess = True
    End If
    Exit Function

Abort:

    ProgramError Err.Number, "Common.TerminateWindowProcess"
End Function


Sub Browse(URL As String)
    Dim Ignore As Variant
    
    On Error GoTo Abort
        
    If Len(BrowserPathname) = 0 Then
        Common.DebugLog "Common.Browser: default brower, URL = " + URL
        Call RunShellExecute("Open", URL, 0&, 0&, SW_SHOWNORMAL)
    Else
        Common.DebugLog "Common.Browser: invoking browser " + BrowserPathname + ", URL = " + URL
        Call RunShellExecute("Open", BrowserPathname, URL, 0&, SW_SHOWNORMAL)
    End If

    Exit Sub

Abort:

    ProgramError Err.Number, "Common.Browse"
    
End Sub

Function GoogleSearchString(theString As String) As String

    Dim Result As String
    Dim theChar As String
    Dim I As Integer
    
    On Error GoTo Abort
    
    Result = ""
    
    For I = 1 To Len(theString)
        theChar = Mid$(theString, I, 1)
        If theChar = " " Then
            Result = Result + "+"
        Else
            Result = Result + theChar
        End If
    Next I
    
    GoogleSearchString = Result
    
    Exit Function

Abort:

    ProgramError Err.Number, "Common.GoogleSearchString"
    
End Function


Function HTTPFilename(theFilename As String) As String

    Dim I As Integer
    Dim theChar As String
    Dim Result As String
    
    On Error GoTo Abort
    
    Result = "file:///"
    
    For I = 1 To Len(theFilename)
        theChar = Mid$(theFilename, I, 1)
        
        Select Case theChar
            Case " "
                Result = Result + "%20"
            Case "\"
                Result = Result + "/"
            Case Else
                Result = Result + theChar
        End Select
        
    Next I
    
    HTTPFilename = Result
    
    Exit Function
    
Abort:
    ProgramError Err.Number, "Common.HTTPFilename"
    
End Function

Function WindowsFilename(HTTPFilename As String) As String

    Dim I As Integer
    Dim theChar As String
    Dim Result As String
    
    On Error GoTo Abort
    
    Result = ""
    
    For I = 1 To Len(HTTPFilename)
        theChar = Mid$(HTTPFilename, I, 1)
        
        Select Case theChar
            Case "/"
                Result = Result + "\"
            Case Else
                Result = Result + theChar
        End Select
        
    Next I
    
    Do
        I = InStr(Result, "%")
        If I = 0 Then Exit Do
        
        If I < (Len(Result) - 2) Then
            Result = Mid$(Result, 1, I - 1) + " " + Mid$(Result, I + 3, Len(Result) - I - 2)
           
        Else
            If I = (Len(Result) - 1) Then
                Result = Mid$(Result, 1, I - 1) + " "
            End If
        End If
            
    Loop
    
    WindowsFilename = Result
    
    Exit Function
    
Abort:
    ProgramError Err.Number, "Common.WindowsFilename"
End Function

Function HTTP_Escape(HTTP As String) As String

    Dim I As Integer
    Dim theResult As String
    Dim theChar As String
    
    On Error GoTo Abort
    
    theResult = ""
    
    For I = 1 To Len(HTTP)
    
        theChar = Mid$(HTTP, I, 1)
        
        Select Case theChar
        
            Case "<"
                theResult = theResult + "%3C"
                
            Case ">"
                theResult = theResult + "%3E"
                
            Case "#"
                theResult = theResult + "%23"
                
            Case "%"
                theResult = theResult + "%25"
                
            Case "{"
                theResult = theResult + "%7B"
                
            Case "}"
                theResult = theResult + "%7D"
                
            Case "|"
                theResult = theResult + "%7C"
                
            Case "\"
                theResult = theResult + "%5C"
                
            Case "^"
                theResult = theResult + "%5E"
                
            Case "~"
                theResult = theResult + "%7E"
                
            Case "["
                theResult = theResult + "%5B"
                
            Case "]"
                theResult = theResult + "%5D"
                
            Case "`"
                theResult = theResult + "%60"
                
            Case ";"
                theResult = theResult + "%3B"
                
            Case "/"
                theResult = theResult + "%2F"
                
            Case "?"
                theResult = theResult + "%3F"
                
            Case ":"
                theResult = theResult + "%3a"
                
            Case "@"
                theResult = theResult + "%40"
            
            Case "="
                theResult = theResult + "%3d"
                
            Case "&"
                theResult = theResult + "%26"
                
            Case "$"
                theResult = theResult + "%24"
                
            Case " "
                theResult = theResult + "%20"
                
            Case Chr(13)
                theResult = theResult + "%0D"
                
            Case Else
                theResult = theResult + theChar
                
        End Select
        
    Next I
    
    HTTP_Escape = theResult
    
    Exit Function

Abort:
    Common.ProgramError Err.Number, "Common.HTTP_Escape"
    
End Function

Sub DisplayWiki(URL As String)
    Dim Ignore As Variant

    
    On Error GoTo Abort
    
    If Len(Trim(URL)) > 0 Then
        If Len(BrowserPathname) = 0 Then
            Call RunShellExecute("Open", URL, 0&, 0&, SW_SHOWNORMAL)
        Else
            Call RunShellExecute("Open", BrowserPathname, URL, 0&, SW_SHOWNORMAL)
        End If
    End If
    Exit Sub

Abort:
    ProgramError Err.Number, "Common.DisplayWiki"
End Sub

Sub InvokeHelp(ContentFilename As String)
    Dim Ignore As Variant
    Dim HelpFilename As String
    
    On Error GoTo Abort
    
    HelpFilename = App.Path + "\Help\" + ContentFilename
    
    If Dir(HelpFilename) = "" Then
        MsgBox "missing help file: " + HelpFilename, vbOKOnly, App.ProductName
    Else
        If Len(BrowserPathname) = 0 Then
            Call RunShellExecute("Open", HTTPFilename(HelpFilename), 0&, 0&, SW_SHOWNORMAL)
        Else
            Call RunShellExecute("Open", BrowserPathname, HTTPFilename(HelpFilename), 0&, SW_SHOWNORMAL)
        End If
    End If
    Exit Sub

Abort:
    ProgramError Err.Number, "Common.InvokeHelp"
End Sub

Function StripExtension(theSimpleName As String) As String

    Dim I As Integer
    
    On Error GoTo Abort
    
    StripExtension = theSimpleName
    
    For I = Len(theSimpleName) To 1 Step -1
        If Mid$(theSimpleName, I, 1) = "." Then
            If I = 1 Then
                Exit Function
            Else
                StripExtension = Mid$(theSimpleName, 1, I - 1)
                Exit Function
            End If
        End If
    Next I
    Exit Function
    
Abort:
    ProgramError Err.Number, "Common.StripExtension: " + theSimpleName
    
End Function

Function SafeFilename(theString) As String
    Dim I As Integer
    Dim Result As String
    
    On Error GoTo Abort
    
    Result = theString
    Do
        I = InStr(Result, "/") + InStr(Result, "\")
        If I = 0 Then Exit Do
        Mid$(Result, I, 1) = "-"
    Loop
    SafeFilename = Result
    Exit Function
    
Abort:
    ProgramError Err.Number, "Common.Safefilename: " + theString
    SafeFilename = theString
End Function

Function ContainingDirectory(Filename As String) As String
    Dim I As Integer
    
    On Error GoTo Abort

    ContainingDirectory = ""
    For I = Len(Filename) To 1 Step -1
    
        If Mid$(Filename, I, 1) = "\" Then
            If Mid$(Filename, I - 1, 1) = ":" Then
                ContainingDirectory = Mid$(Filename, 1, 3) 'Containing Directory is root of a drive
            Else
                ContainingDirectory = Mid$(Filename, 1, I - 1)
            End If
            
            Exit Function
        End If
        
    Next I
    
    Exit Function
    
Abort:
    ProgramError Err.Number, "Common.ContainingDirectory, Filename = " + Filename
    
End Function

Function SimpleName(Filename As String) As String
    Dim LastSlash As Integer
    Dim NextSlash As Integer
    
    On Error GoTo Abort
    
    LastSlash = 0
    Do
        NextSlash = InStr(LastSlash + 1, Filename, "\")
        If NextSlash = 0 Then Exit Do
        LastSlash = NextSlash
    
    Loop
    If LastSlash = 0 Then
        SimpleName = Filename
    Else
        SimpleName = Mid$(Filename, LastSlash + 1, Len(Filename) - LastSlash)
    End If
    Exit Function
    
Abort:
    ProgramError Err.Number, "Common.SimpleName"
End Function

Sub Log(Item As String)

    Dim FileSize As Long
    
    Dim LCID As Long
    
    Dim MonitorSleepCount As Integer
    
    On Error Resume Next
    FileSize = FileLen(EventLogFilename) '2012-02-13
    If Error.Number = 0 Then
        If FileSize > MaxEventLogFilenameLen Then  '2012-12-06
            Common.SetDebug False
            Exit Sub
        End If
    End If
    
    theLogFile = FreeFile
    
    Open EventLogFilename For Append As #theLogFile
    
    If Not EventLogExists Then  '2012-12-06
        EventLogExists = (Len(Dir(EventLogFilename)) > 0)
    End If
    
    If Not StartupLogged Then

        LCID = LocaleInfo.GetLocaleID
        
        Print #theLogFile,
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; App.ProductName + " version "; Format$(App.Major) + "." + Format$(App.Minor) + "." + Format$(App.Revision)
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "App.Path          : "; App.Path
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "App.exe           : "; App.EXEName
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "Operating System  : "; GetOSName + " (" + Format$(OSWordLength) + "-bit) build " + Format$(GetOSBuild)
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "Locale ID         : "; Format$(LCID) + " (0x" + Hex(LCID) + ")"
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "ANSI CodePage     : "; LocaleInfo.GetLocaleANSICodePage
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "OEM CodePage      : "; LocaleInfo.GetLocaleOEMCodePage
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "Country           : "; LocaleInfo.GetLocaleCountry
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "Language          : "; LocaleInfo.GetLocaleLanguage
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "DecimalSeparator  : "; LocaleInfo.GetLocaleDecimalSeparator
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "ThousandSeparator : "; LocaleInfo.GetLocaleThousandSeparator
        Print #theLogFile, Format$(StartTime, "dd-mmm-yyyy hh:nn:ss"); " > "; "DXLab Apps        : "; Trim$(GetInteropCaption)
        
        Load CommonUI 'enumerate monitors
        
        StartupLogged = True
        
        ErrorLogExistsFlag = True
        ErrorLogExists 'blind call to procedure that indicates a log exists
        
    End If
    
    Print #theLogFile, Format$(UTC.CurrentTime, "dd-mmm-yyyy hh:nn:ss"); " > "; Item
    
    Close #theLogFile
                
End Sub

Sub ProgramError(ErrorNumber As Long, Module As String)
   Log "program error " + Format$(ErrorNumber) + " in module " + Module + ": " + Error(ErrorNumber)
End Sub

Function Version() As String
    On Error GoTo Abort

    Version = Format(App.Major) + "." + Format(App.Minor) + "." + Format(App.Revision)
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.Version"

End Function

Function GetVersionValue(Version As String) As String
    
    Const MaxComponents = 5
    Dim theVersion As String
    Dim VersionArray(MaxComponents) As String
    Dim I As Integer
    Dim Pos As Integer
    Dim Last As Integer
    Dim Components As Integer
    
    On Error GoTo Abort
    
    'convert string X.Y.Z to string XYZ

    theVersion = Version + "."
    
    Last = 0
    Components = 0
    For I = 1 To MaxComponents
        Pos = InStr(Last + 1, theVersion, ".")
        If Pos = 0 Then Exit For
        Components = Components + 1
        VersionArray(I) = Mid$(theVersion, Last + 1, Pos - Last - 1)
        Last = Pos
    Next I
            
    GetVersionValue = ""
    
    Select Case Components
    
        Case 1
            GetVersionValue = VersionArray(1)

        Case 2
            GetVersionValue = VersionArray(1) + VersionArray(2)
            
        Case 3
            GetVersionValue = VersionArray(1) + VersionArray(2) + VersionArray(3)
            
        Case 4
            GetVersionValue = VersionArray(1) + VersionArray(2) + VersionArray(4)
        
        Case 5
            GetVersionValue = VersionArray(1) + VersionArray(2) + VersionArray(4)
    
    End Select
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetVersionValue"

End Function

Function GetFileVersion(RawFilename) As VersionInfo
    Const MaxComponents = 5
    Dim theVersion As String
    Dim VersionArray(MaxComponents) As String
    Dim I As Integer
    Dim Pos As Integer
    Dim Last As Integer
    Dim Components As Integer
    Dim Filename As String
    
    Dim ObjFSO
    
    On Error GoTo Abort
    
    On Error Resume Next
    Set ObjFSO = CreateObject("scripting.filesystemobject")
    If Err.Number <> 0 Then
        Common.Log "Common.GetFileVersion: Windows Scripting Host failure: " + Format$(Err.Number) + " " + Err.Description
        Exit Function
    End If
    On Error GoTo Abort
    
    GetFileVersion.Version = ""
    GetFileVersion.Major = 0
    GetFileVersion.Minor = 0
    GetFileVersion.Revision = 0
    
    Filename = Trim$(RawFilename)
    
    If Len(Filename) = 0 Then Exit Function
    
    On Error Resume Next
    If Len(Dir(Filename)) = 0 Then Exit Function
    If Err.Number > 0 Then Exit Function
    On Error GoTo Abort
    
    theVersion = ObjFSO.GetFileVersion(Filename)
    If Len(Trim$(theVersion)) = 0 Then
        GetFileVersion.Version = "?"
        Exit Function
    End If
    
    If Mid$(theVersion, Len(theVersion), 1) <> "." Then
        theVersion = theVersion + "."
    End If
    
    Last = 0
    Components = 0
    For I = 1 To MaxComponents
        Pos = InStr(Last + 1, theVersion, ".")
        If Pos = 0 Then Exit For
        Components = Components + 1
        VersionArray(I) = Mid$(theVersion, Last + 1, Pos - Last - 1)
        Last = Pos
    Next I
        
    GetFileVersion.Major = VersionArray(1)
    
    Select Case Components
    
        Case 1
            GetFileVersion.Version = VersionArray(1)

        Case 2
            GetFileVersion.Version = VersionArray(1) + "." + VersionArray(2)
            GetFileVersion.Major = VersionArray(2)
            
        Case 3
            GetFileVersion.Version = VersionArray(1) + "." + VersionArray(2) + "." + VersionArray(3)
            GetFileVersion.Minor = VersionArray(2)
            GetFileVersion.Revision = VersionArray(3)
            
        Case 4
            GetFileVersion.Version = VersionArray(1) + "." + VersionArray(2) + "." + VersionArray(4)
            GetFileVersion.Minor = VersionArray(2)
            GetFileVersion.Revision = VersionArray(4)
        
        Case 5
            GetFileVersion.Version = VersionArray(1) + "." + VersionArray(2) + "." + VersionArray(4)
            GetFileVersion.Minor = VersionArray(2)
            GetFileVersion.Revision = VersionArray(4)
    
    End Select
    
    Exit Function
   
Abort:

    Common.ProgramError Err.Number, "Common.GetFileVersion"
    Common.Log "   filename = " + Filename
    Common.Log "   version  = " + theVersion
    
End Function

Function Max(X As Integer, Y As Integer) As Integer
    On Error GoTo Abort

    If X > Y Then
        Max = X
    Else
        Max = Y
    End If
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.Max"

End Function

Function Min(X As Integer, Y As Integer) As Integer
    On Error GoTo Abort

    If X > Y Then
        Min = Y
    Else
        Min = X
    End If
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.Min"

End Function

Function IsDate(theCandidate As String) As Boolean
    Dim TestDate As Date
    
    On Error GoTo Abort

    IsDate = False
    If Len(theCandidate) = 0 Then Exit Function
    On Error GoTo NotADate
    TestDate = CDate(theCandidate)
    On Error GoTo Abort
    IsDate = True
    Exit Function

NotADate:
    IsDate = False
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.IsDate"

End Function

Function IsDigit(theData As String) As Boolean
    Dim theChar As String
        
    On Error GoTo Abort
    IsDigit = False
    
    On Error GoTo NotADigit
    
    If Len(theData) = 0 Then
        Exit Function
    End If
    
    theChar = Mid$(theData, 1, 1)
    IsDigit = (Asc(theChar) >= Asc("0")) And (Asc(theChar) <= Asc("9"))
    Exit Function

NotADigit:
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.IsDigit"

End Function

Function IsLetter(theData As String) As Boolean
    Dim theChar As String
        
    '2016-01-02 SC 7.4.3
    On Error GoTo Abort
    IsLetter = False
    
    On Error GoTo NotADigit
    
    If Len(theData) = 0 Then
        Exit Function
    End If
    
    theChar = UCase$(Mid$(theData, 1, 1))
    IsLetter = (Asc(theChar) >= Asc("A")) And (Asc(theChar) <= Asc("Z"))
    Exit Function

NotADigit:
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.IsLetter"

End Function

Function ContainsDigits(theData As String) As Boolean

    Dim I As Integer
    
    On Error GoTo Abort
    
    ContainsDigits = False
    If Len(theData) = 0 Then Exit Function
    
    For I = 1 To Len(theData)
        If Common.IsDigit(Mid$(theData, I, 1)) Then
            ContainsDigits = True
            Exit Function
        End If
    Next I
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.ContainsDigits"
End Function

Function IsInteger(Candidate As String) As Boolean
    Dim I As Integer
    Dim Param As String
    Dim char As String
    
    On Error GoTo Abort

    IsInteger = False
    
    On Error GoTo NotAnInteger
    
    Param = LTrim(Candidate)
    
    IsInteger = False
    
    If Len(Param) = 0 Then Exit Function
    
    For I = 1 To Len(Param)
        char = Mid$(Param, I, 1)
        
        If char <> "+" And char <> "-" Then
            If char < "0" Or Mid$(Param, I, 1) > "9" Then
                IsInteger = False
                Exit Function
            Else
                IsInteger = True
            End If
        End If
        
    Next I
    
    If Len(Candidate) = 1 Then
        IsInteger = True
        Exit Function
    End If
    
    If (Candidate > 32767) Or (Candidate < -32768) Then
        IsInteger = False
    End If
    Exit Function

NotAnInteger:
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.IsInteger"

End Function

Function IsLong(Candidate As String) As Boolean
    Dim I As Integer
    Dim Param As String
    Dim char As String
    
    On Error GoTo Abort

    IsLong = False
    
    On Error GoTo NotAnInteger
    
    Param = LTrim(Candidate)
    
    IsLong = False
    
    If Len(Param) = 0 Then Exit Function
    
    For I = 1 To Len(Param)
        char = Mid$(Param, I, 1)
        
        If char <> "+" And char <> "-" Then
            If char < "0" Or Mid$(Param, I, 1) > "9" Then
                IsLong = False
                Exit Function
            Else
                IsLong = True
            End If
        End If
        
    Next I
    
    If Len(Candidate) = 1 Then
        IsLong = True
        Exit Function
    End If
    
    If (Candidate > 2 ^ 31) Or (Candidate < -(2 ^ 31)) Then
        IsLong = False
    End If
    Exit Function

NotAnInteger:
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.IsLong"

End Function

Function IsReal(Candidate As String) As Boolean
    Dim I As Integer
    Dim Param As String
    Dim char As String
    Dim FoundNumber As Boolean
    
    On Error GoTo Abort
    IsReal = False
    
    On Error GoTo NotAReal
    Param = LTrim(Candidate)
    
    FoundNumber = False
    
    
    If Len(Param) = 0 Then Exit Function
    
    For I = 1 To Len(Param)
        char = Mid$(Param, I, 1)
        
        If char <> "+" And char <> "-" And char <> LocaleInfo.GetLocaleDecimalSeparator Then
            If char < "0" Or Mid$(Param, I, 1) > "9" Then Exit Function
            FoundNumber = True
        End If
        
    Next I
    
    IsReal = FoundNumber
    
    Exit Function

NotAReal:
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.IsReal"

End Function

Function IsFormattedReal(Candidate As String) As Boolean
    Dim I As Integer
    Dim Param As String
    Dim char As String
    Dim FoundNumber As Boolean
    
    On Error GoTo Abort
    
    IsFormattedReal = False
    
    On Error GoTo NotAReal
    
    Param = LTrim(Candidate)
    
    FoundNumber = False
    
    
    If Len(Param) = 0 Then Exit Function
    
    For I = 1 To Len(Param)
        char = Mid$(Param, I, 1)
        
        If (char <> "+") And (char <> "-") And (char <> LocaleInfo.GetLocaleDecimalSeparator) And (char <> LocaleInfo.GetLocaleThousandSeparator) Then
            If char < "0" Or Mid$(Param, I, 1) > "9" Then Exit Function
            FoundNumber = True
        End If
        
    Next I
    
    IsFormattedReal = FoundNumber
    
    Exit Function

NotAReal:
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.IsFormattedReal"

End Function

Function IsCallsign(Candidate) As Boolean
    
    Dim theWord As String
    Dim theCharCode As Integer
    Dim I As Integer
    Dim FoundNumbers As Boolean
    Dim FoundLetters As Boolean
    Dim FoundSymbols As Boolean
    
    On Error GoTo Abort
    
    IsCallsign = False
    
    If InStr(Candidate, "/") > 0 Then
        If Len(Candidate) > 13 Then Exit Function
    Else
        If Len(Candidate) > 7 Then Exit Function
    End If
    
    theWord = Trim$(Candidate)
    If InStr(theWord, " ") > 0 Then Exit Function
    
    FoundNumbers = False
    FoundLetters = False
    FoundSymbols = False
    
    For I = 1 To Len(theWord)
        theCharCode = Asc(Mid$(theWord, I, 1))
        If (theCharCode >= Asc("0")) And (theCharCode <= Asc("9")) Then
            FoundNumbers = True
        ElseIf theCharCode = SlashZeroCode Then 'slash-0
            FoundNumbers = True
        ElseIf ((theCharCode >= Asc("A")) And (theCharCode <= Asc("Z"))) Or ((theCharCode >= Asc("a")) And (theCharCode <= Asc("z"))) Then
            FoundLetters = True
        ElseIf Not theCharCode = Asc("/") Then
            FoundSymbols = True
        End If
    Next I

    IsCallsign = FoundNumbers And FoundLetters And Not (FoundSymbols)
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.IsCallsign"
    IsCallsign = False
End Function

Function BaseCallsign(FullCallsign As String) As String
    
    Dim Slash1 As Integer
    Dim Slash2 As Integer
    Dim Part1 As String
    Dim Part2 As String
    Dim Part3 As String
    Dim Result As String
    
    On Error GoTo Abort
   
    Slash1 = InStr(FullCallsign, "/")
    If Slash1 = 0 Then
        Result = FullCallsign
    
    ElseIf Slash1 = 1 Then
        Result = Common.BaseCallsign(Mid$(FullCallsign, 2, Len(FullCallsign) - 1))
    
    Else
        Slash2 = InStr(Slash1 + 1, FullCallsign, "/")
        If Slash2 = 0 Then
            If (Slash1 - 1) > (Len(FullCallsign) - Slash1) Then
                Result = Mid$(FullCallsign, 1, Slash1 - 1)
            Else
                Result = Mid$(FullCallsign, Slash1 + 1, Len(FullCallsign) - Slash1)
            End If
        
        ElseIf Slash2 = Len(FullCallsign) Then
            Result = Common.BaseCallsign(Mid$(FullCallsign, 1, Len(FullCallsign) - 1))
        
        ElseIf Slash2 = Slash1 + 1 Then
            Result = Common.BaseCallsign(Mid$(FullCallsign, 1, Slash1 - 1) + "/" + Mid$(FullCallsign, Slash2 + 1, Len(FullCallsign) - Slash2))

        Else
            Part1 = Mid$(FullCallsign, 1, Slash1 - 1)
            Part2 = Mid$(FullCallsign, Slash1 + 1, Slash2 - Slash1 - 1)
            Part3 = Mid$(FullCallsign, Slash2 + 1, Len(FullCallsign) - Slash2)
            
            Select Case LCase$(Part3)
            
                Case "b", "a", "m", "p"
                    Result = Common.BaseCallsign(Part1 + "/" + Part2)
                
                Case Else
                    Result = Mid$(FullCallsign, Slash1 + 1, Slash2 - Slash1 - 1)
                    
            End Select
        End If
    End If
    
    BaseCallsign = Result
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.BaseCallsign"

End Function

Function SetCombo(theCombo As Control, theItem As String) As Boolean
    Dim I As Integer
    
    On Error GoTo Abort

    SetCombo = False
    
    If UCase$(theCombo.Text) = UCase$(theItem) Then '6.7.2
        SetCombo = True
        Exit Function
    End If
    
    For I = 0 To theCombo.ListCount - 1
        If UCase$(theCombo.List(I)) = UCase(theItem) Then
            theCombo.ListIndex = I
            SetCombo = True
            Exit Function
        End If
    Next I
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.SetCombo"

End Function

Function SearchCombo(theCombo As Control, theItem As String) As Integer
    Dim I As Integer
    
    On Error GoTo Abort

    SearchCombo = -1
    
    For I = 0 To theCombo.ListCount - 1
        If UCase$(theCombo.List(I)) = UCase(theItem) Then
            SearchCombo = I
            Exit Function
        End If
    Next I
    
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.SearchCombo"

End Function

Function DoubleAmpersand(theData As String) As String

    Dim Pos As Integer
    
    On Error GoTo Abort
    
    Pos = InStr(theData, "&")
    
    If Pos = 0 Then
        DoubleAmpersand = theData
    ElseIf Pos = Len(theData) Then
        DoubleAmpersand = theData + "&"
    Else
        DoubleAmpersand = Mid$(theData, 1, Pos) + "&" + DoubleAmpersand(Mid$(theData, Pos + 1, Len(theData) - Pos))
    End If
     
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.DoubleAmpersand"
    DoubleAmpersand = ""

End Function

Function ValidCallsign(theCall As String) As Boolean

    Dim UpperCall As String
    Dim I As Integer
    Dim FoundNumber As Boolean
    Dim FoundLetter As Boolean
    Dim FoundGarbage As Boolean
    Dim theChar As String
    
    On Error GoTo Abort
    
    UpperCall = UCase$(theCall)
    FoundNumber = False
    FoundLetter = False
    FoundGarbage = False
    
    For I = 1 To Len(UpperCall)
        theChar = Mid$(UpperCall, I, 1)
        If IsInteger(theChar) Then
            FoundNumber = True
        ElseIf (theChar >= "A") And (theChar <= "Z") Then
            FoundLetter = True
        ElseIf (theChar <> "/") And (theChar <> "") Then
            FoundGarbage = True     '9.6.7
        End If
    Next I
    
    ValidCallsign = FoundNumber And FoundLetter And (Not FoundGarbage)    '9.6.7
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.ValidCallsign"
    ValidCallsign = False
End Function

Sub ActivateWindow(hWndCtlApp As Long)

    Dim currWinP As WINDOWPLACEMENT
    
    On Error GoTo Abort
   
    If hWndCtlApp Then
   
        'prepare the WINDOWPLACEMENT type
        currWinP.Length = Len(currWinP)
   
        If GetWindowPlacement(hWndCtlApp, currWinP) > 0 Then
      
            'determine the window state
            If currWinP.showCmd = SW_SHOWMINIMIZED Then
      
                'minimized, so restore
                 currWinP.Length = Len(currWinP)
                 currWinP.Flags = 0&
                 currWinP.showCmd = SW_SHOWNORMAL
                 Call SetWindowPlacement(hWndCtlApp, currWinP)
         
            Else
           
                'on screen, so assure visible
                 Call SetForegroundWindow(hWndCtlApp)
                 Call BringWindowToTop(hWndCtlApp)
         
            End If
      
        End If
   
    End If
   
    Exit Sub

Abort: Common.ProgramError Err.Number, "Common.ActivateWindow"

End Sub

Public Sub MakeNormalZOrder(hwnd As Long)
    Dim theResult As Long
    
    On Error GoTo Abort

    theResult = SetWindowPos(hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, TOPMOST_FLAGS)
    Exit Sub

Abort:

    Common.ProgramError Err.Number, "Common.MakeNormalZOrder"

End Sub

Public Sub MakeTopMostZOrder(hwnd As Long)
    Dim theResult As Long
    
    On Error GoTo Abort

    theResult = SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, TOPMOST_FLAGS)
    Exit Sub

Abort:

    Common.ProgramError Err.Number, "Common.MakeTopMostZOrder"

End Sub

Function IsURL(Candidate As String) As Boolean

    Dim LowerCandidate As String
    
    On Error GoTo Abort
    
    IsURL = False
    
    LowerCandidate = LCase$(Candidate)
    
    If Mid$(LowerCandidate, 1, 7) = "http://" Then
        IsURL = True
    ElseIf Mid$(LowerCandidate, 1, 4) = "www." Then
        IsURL = True
    End If
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.IsURL"

End Function

Function GetFileErrorDescription(theCode As Long) As String

    On Error GoTo Abort
    
    GetFileErrorDescription = "unknown error " + Format$(theCode)
    
    Select Case theCode
    
        Case &H80004004
            GetFileErrorDescription = "existing file is 'read-only'"
            
        Case &H8007000E
            GetFileErrorDescription = "put of memory"
            
        Case &H80070005
            GetFileErrorDescription = "access denied"
            
        Case &H800C0002
            GetFileErrorDescription = "invalid URL"

        Case &H800C0003
            GetFileErrorDescription = "no session"
        
        Case &H800C0004
            GetFileErrorDescription = "cannot connect"
        
        Case &H800C0005
            GetFileErrorDescription = "resource not found"
        
        Case &H800C0006
            GetFileErrorDescription = "object not found"
        
        Case &H800C0007
            GetFileErrorDescription = "data not available"
        
        Case &H800C0008
            GetFileErrorDescription = "download failure"
        
        Case &H800C0009
            GetFileErrorDescription = "authentication required"
        
        Case &H800C000A
            GetFileErrorDescription = "no valid media"
        
        Case &H800C000B
            GetFileErrorDescription = "connection timeout"
        
        Case &H800C000C
            GetFileErrorDescription = "invalid request"
        
        Case &H800C000D
            GetFileErrorDescription = "unknown protocol"
        
        Case &H800C000E
            GetFileErrorDescription = "security problem"
        
        Case &H800C000F
            GetFileErrorDescription = "cannot load data"
        
        Case &H800C0010
            GetFileErrorDescription = "cannot instantiate object"
        
        Case &H800C0013
            GetFileErrorDescription = "query option unknown"
        
        Case &H800C0014
            GetFileErrorDescription = "redirect failed"
        
        Case &H800C0015
            GetFileErrorDescription = "redirect to dir"
        
        Case &H800C0016
            GetFileErrorDescription = "cannot lock request"
        
        Case Else
            GetFileErrorDescription = "unknown error " + Format$(theCode)
            
    End Select

    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.GetFileErrorDescription"
    
End Function

Function GetFileFromURL(ByVal theURL As String, theFilename As String) As String
    
    Dim Result As Long
    
    Dim CachedURL As String
    Dim I As Integer
    Dim theChar As String
    Dim theMessage As String
    
    On Error GoTo Abort
    
    If Common.GetDebug Then
        Common.Log "Common.GetFileFromURL: starting"
        Common.Log "   theURL = " + theURL
        Common.Log "   theFile = " + theFilename
    End If
    
    GetFileFromURL = "Program Error"
    
    CachedURL = ""
    For I = 1 To Len(theURL)
        theChar = Mid$(theURL, I, 1)
        If theChar = " " Then
            CachedURL = CachedURL + "%20"
        Else
            CachedURL = CachedURL + theChar
        End If
    Next I
    
    Result = DeleteUrlCacheEntry(CachedURL) 'returns 1 if cached URL is deleted
    If Common.GetDebug Then
        Common.Log "   CachedURL = " + CachedURL
        Common.Log "   Deletion Result = " + Format$(Result)
    End If
    
    Result = URLDownloadToFile(0, theURL, theFilename, BINDF_GETNEWESTVERSION, 0)
    
    If Result = URLDownloadToFile_SUCCESS Then
        GetFileFromURL = ""
    Else
        theMessage = Common.GetFileErrorDescription(Result)
        GetFileFromURL = theMessage
        Common.DebugLog "Common.GetFileFromURL failed: " + theMessage + ", error code = " + Format$(Result)
        Exit Function
    End If

    Common.DebugLog "Common.GetFileFromURL: complete"
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.GetFileFromURL"
    
End Function

Function GetIniFileSetting(Filename As String, Section As String, Setting As String) As String
    
    Dim theFile As Integer
    Dim theLine As String
    Dim CurrentSection As String
    Dim CurrentSetting As String
    Dim SectionStart As Integer
    Dim SectionEnd As Integer
    Dim SettingStart As Integer

    Dim TargetSection As String
    Dim TargetSetting As String
    
    On Error GoTo Abort
    
    GetIniFileSetting = ""
    
    If Len(Dir$(Filename)) = 0 Then Exit Function
    
    TargetSection = UCase$(Trim$(Section))
    TargetSetting = UCase$(Trim$(Setting))
    
    theFile = FreeFile
    CurrentSection = ""
    Open Filename For Input As theFile
    
    Do
        If EOF(theFile) Then Exit Do
        
        Line Input #theFile, theLine
        
        theLine = Trim$(theLine)
        
        If Len(theLine) > 0 Then
            SectionStart = InStr(theLine, "[")
            SectionEnd = InStr(theLine, "]")
            If (SectionStart > 0) And (SectionEnd > SectionStart) Then
                CurrentSection = UCase$(Trim$(Mid$(theLine, SectionStart + 1, SectionEnd - SectionStart - 1)))
            Else
                If CurrentSection = TargetSection Then
                    SettingStart = InStr(theLine, "=")
                    If SettingStart > 0 Then
                        CurrentSetting = UCase$(Trim$(Mid$(theLine, 1, SettingStart - 1)))
                        If CurrentSetting = TargetSetting Then
                            GetIniFileSetting = UCase$(Trim$(Mid$(theLine, SettingStart + 1, Len(theLine) - SettingStart)))
                            Exit Do
                        End If
                    End If
                End If
            End If
        End If
    Loop
    
    Close theFile
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetIniFileSetting"

End Function


Function UpdateIniFileSetting(Filename As String, Section As String, Setting As String, NewValue As String) As Boolean
    
    Dim ObjFSO
    
    Dim theInFile As Integer
    Dim theOutFile As Integer
    
    Dim theLine As String
    Dim CurrentSection As String
    Dim CurrentSetting As String
    Dim SectionStart As Integer
    Dim SectionEnd As Integer
    Dim SettingStart As Integer

    Dim TargetSection As String
    Dim TargetSetting As String
    
    Dim Foldername As String
    Dim SimpleName As String
    Dim OriginalFilename As String
    
    On Error GoTo Abort
    
    UpdateIniFileSetting = False
    
    If Len(Dir$(Filename)) = 0 Then Exit Function
    
    On Error Resume Next
    Set ObjFSO = CreateObject("scripting.filesystemobject")
    If Err.Number <> 0 Then
        Common.Log "Common.UpdateIniFileSetting: Windows Scripting Host failure: " + Format$(Err.Number) + " " + Err.Description
        Exit Function
    End If
    On Error GoTo Abort
    
    Foldername = Common.ContainingDirectory(Filename)
    SimpleName = Common.SimpleName(Filename)
    OriginalFilename = Foldername + "\" + Common.StripExtension(SimpleName) + "_original.ini"
    
    On Error Resume Next
    ObjFSO.movefile Filename, OriginalFilename
    If Err.Number <> 0 Then
        Common.DebugLog "Common.UpdateIniFileSetting: unable to copy " + Filename
        Exit Function
    End If
    On Error GoTo Abort
    
    TargetSection = UCase$(Trim$(Section))
    TargetSetting = UCase$(Trim$(Setting))
    
    CurrentSection = ""
    theInFile = FreeFile
    Open OriginalFilename For Input As theInFile
    
    theOutFile = FreeFile
    Open Filename For Output As theOutFile
    
    Do
        If EOF(theInFile) Then Exit Do
        
        Line Input #theInFile, theLine
                
        If Len(theLine) > 0 Then
            SectionStart = InStr(theLine, "[")
            SectionEnd = InStr(theLine, "]")
            If (SectionStart > 0) And (SectionEnd > SectionStart) Then
                CurrentSection = UCase$(Trim$(Mid$(theLine, SectionStart + 1, SectionEnd - SectionStart - 1)))
                Print #theOutFile, theLine
            Else
                If CurrentSection = TargetSection Then
                    SettingStart = InStr(theLine, "=")
                    If SettingStart > 0 Then
                        CurrentSetting = UCase$(Trim$(Mid$(theLine, 1, SettingStart - 1)))
                        If CurrentSetting = TargetSetting Then
                            Print #theOutFile, Mid$(theLine, 1, SettingStart) + NewValue
                        Else
                            Print #theOutFile, theLine
                        End If
                    End If
                Else
                    Print #theOutFile, theLine
                End If
            End If
        Else
            Print #theOutFile, theLine
        End If
    Loop
    
    Close theInFile
    Close theOutFile
    
    Kill OriginalFilename
    
    Exit Function
    
Abort:

    Common.ProgramError Err.Number, "Common.UpdateIniFileSetting"

End Function

Function GetGlobalMemoryUsage() As String

    On Error GoTo Abort
    
    Dim MemStat As MemoryStatusEx

    Const OneKb As Long = 1024
    Const OneMb As Long = OneKb * OneKb
    
    Const CurMult As Long = 10000

    MemStat.dwLength = Len(MemStat)
    
    GetGlobalMemoryUsage = ""
    
    If (GlobalMemoryStatusEx(MemStat)) Then
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Memory load:                " & CStr(MemStat.dwMemoryLoad) & "%" + vbCrLf
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Total physical:             " & CStr((CDec(MemStat.ullTotalPhys) * CurMult) / OneMb) & " mb" + vbCrLf
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Available physical:         " & CStr((CDec(MemStat.ullAvailPhys) * CurMult) / OneMb) & " mb" + vbCrLf
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Total page-file:            " & CStr((CDec(MemStat.ullTotalPageFile) * CurMult) / OneMb) & " mb" + vbCrLf
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Available page-file:        " & CStr((CDec(MemStat.ullAvailPageFile) * CurMult) / OneMb) & " mb" + vbCrLf
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Total virtual:              " & CStr((CDec(MemStat.ullTotalVirtual) * CurMult) / OneMb) & " mb" + vbCrLf
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Available virtual:          " & CStr((CDec(MemStat.ullAvailVirtual) * CurMult) / OneMb) & " mb" + vbCrLf
        GetGlobalMemoryUsage = GetGlobalMemoryUsage + "Available extended virtual: " & CStr((CDec(MemStat.ullAvailExtendedVirtual) * CurMult) / OneMb) & " mb" + vbCrLf
    End If
    Exit Function
    
Abort:

    Common.ProgramError Err.Number, "Common.GetGlobalMemoryUsage"
End Function

Sub SetGlobalMemoryUsageCheckpoint()

    On Error GoTo Abort
    
    MemoryUsageCheckpoint.dwLength = Len(MemoryUsageCheckpoint)
    GlobalMemoryStatusEx MemoryUsageCheckpoint
    Exit Sub
Abort:

    Common.ProgramError Err.Number, "Common.SetGlobalMemoryUsageCheckpoint"
End Sub

Function GetGlobalMemoryUsageIncrement() As String

    On Error GoTo Abort
    
    Dim MemStat As MemoryStatusEx

    Const OneKb As Long = 1024
    Const OneMb As Long = OneKb * OneKb
    
    Const CurMult As Long = 10000

    MemStat.dwLength = Len(MemStat)
    
    GetGlobalMemoryUsageIncrement = ""
    
    If (GlobalMemoryStatusEx(MemStat)) Then
        GetGlobalMemoryUsageIncrement = GetGlobalMemoryUsageIncrement + "Total physical:             " & CStr((CDec(MemoryUsageCheckpoint.ullTotalPhys - MemStat.ullTotalPhys) * CurMult) / OneKb) & " kb" + vbCrLf
        GetGlobalMemoryUsageIncrement = GetGlobalMemoryUsageIncrement + "Available physical:         " & CStr((CDec(MemoryUsageCheckpoint.ullAvailPhys - MemStat.ullAvailPhys) * CurMult) / OneKb) & " kb" + vbCrLf
        GetGlobalMemoryUsageIncrement = GetGlobalMemoryUsageIncrement + "Total page-file:            " & CStr((CDec(MemoryUsageCheckpoint.ullTotalPageFile - MemStat.ullTotalPageFile) * CurMult) / OneKb) & " kb" + vbCrLf
        GetGlobalMemoryUsageIncrement = GetGlobalMemoryUsageIncrement + "Available page-file:        " & CStr((CDec(MemoryUsageCheckpoint.ullAvailPageFile - MemStat.ullAvailPageFile) * CurMult) / OneKb) & " kb" + vbCrLf
        GetGlobalMemoryUsageIncrement = GetGlobalMemoryUsageIncrement + "Total virtual:              " & CStr((CDec(MemoryUsageCheckpoint.ullTotalVirtual - MemStat.ullTotalVirtual) * CurMult) / OneKb) & " kb" + vbCrLf
        GetGlobalMemoryUsageIncrement = GetGlobalMemoryUsageIncrement + "Available virtual:          " & CStr((CDec(MemoryUsageCheckpoint.ullAvailVirtual - MemStat.ullAvailVirtual) * CurMult) / OneKb) & " kb" + vbCrLf
        GetGlobalMemoryUsageIncrement = GetGlobalMemoryUsageIncrement + "Available extended virtual: " & CStr((CDec(MemoryUsageCheckpoint.ullAvailExtendedVirtual - MemStat.ullAvailExtendedVirtual) * CurMult) / OneKb) & " kb" + vbCrLf
    End If
    Exit Function
    
Abort:

    Common.ProgramError Err.Number, "Common.GetGlobalMemoryUsageIncrement"
    
End Function

Function DoubleApostrophe(theMessage As String) As String

    Dim theResult As String
    Dim theChar As String
    Dim I As Integer
    
    On Error GoTo Abort
    
    theResult = ""
    If Len(theMessage) > 0 Then
    
        For I = 1 To (Len(theMessage) - 1)
            theChar = Mid$(theMessage, I, 1)
            If theChar = "&" Then
                If Mid$(theMessage, I + 1, 1) <> "&" Then
                    theResult = theResult + "&" 'insert extra &
                End If
            End If
            theResult = theResult + theChar
        Next I
        
        theChar = Mid$(theMessage, Len(theMessage), 1)
        If theChar = "&" Then
            If Len(theMessage) = 1 Then
                theResult = "&&"  'single &
            ElseIf Mid$(theMessage, Len(theMessage) - 1, 1) <> "&" Then
                theResult = theResult + "&&"  'trailing single &
            Else
                theResult = theResult + "&" 'trailing double &
            End If
        End If
                
    End If
    
    DoubleApostrophe = theResult
    
    Exit Function
    
Abort:

    Common.ProgramError Err.Number, "Common.DoubleApostrophe"

End Function

Function CloseColorComponent(Component1 As Integer, Component2 As Integer) As Boolean
    On Error GoTo Abort

    CloseColorComponent = Abs(Component1 - Component2) < 128
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.CloseColorComponent"
    CloseColorComponent = True
End Function

Function CloseColors(Color1 As Long, Color2 As Long) As Boolean
    
    Dim theColor1 As Integer
    Dim theColor2 As Integer
    
    On Error GoTo Abort
    CloseColors = False
    
    theColor1 = Color1 And 255
    theColor2 = Color2 And 255
    If Not Common.CloseColorComponent(theColor1, theColor2) Then Exit Function
    
    theColor1 = (Color1 \ 256) And 255
    theColor2 = (Color2 \ 256) And 255
    If Not Common.CloseColorComponent(theColor1, theColor2) Then Exit Function
    
    theColor1 = (Color1 \ 65536) And 255
    theColor2 = (Color2 \ 65536) And 255
    If Not Common.CloseColorComponent(theColor1, theColor2) Then Exit Function
    
    CloseColors = True
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.CloseColors"
    CloseColors = True
End Function

Sub ChooseDefaultFont()

    Dim I As Integer
    
    On Error GoTo Abort
    
    DefaultFont = "MS Sans Serif"
    
    For I = 0 To Screen.FontCount
    
        If Screen.Fonts(I) = "Microsoft Sans Serif" Then
            DefaultFont = Screen.Fonts(I)
            Exit Sub
        End If
    Next

    Exit Sub
    
Abort: Common.ProgramError Err.Number, "Common.ChooseDefaultFont"

End Sub

Function GetDefaultFont() As String

    On Error GoTo Abort
    
    If Len(DefaultFont) = 0 Then
        Common.ChooseDefaultFont
    End If
    
    GetDefaultFont = DefaultFont

    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.GetDefaultFont"

End Function

Sub ChooseUnicodeFont()

    Dim I As Integer
    
    On Error GoTo Abort
    
    UnicodeFont = "MS Sans Serif"
    
    For I = 0 To Screen.FontCount
    
        If Screen.Fonts(I) = "Microsoft Sans Serif" Then
             UnicodeFont = Screen.Fonts(I)
             Exit Sub
             
        ElseIf Screen.Fonts(I) = "Tahoma" Then
            UnicodeFont = Screen.Fonts(I)
            
        ElseIf Screen.Fonts(I) = "Lucida Sans Unicode" Then
            If UnicodeFont <> "Tahoma" Then
                UnicodeFont = Screen.Fonts(I)
            End If
        End If
    Next

    Exit Sub
    
Abort: Common.ProgramError Err.Number, "Common.ChooseUnicodeFont"

End Sub

Function GetUnicodeFont() As String

    On Error GoTo Abort
    
    If Len(UnicodeFont) = 0 Then
        Common.ChooseUnicodeFont
    End If
    
    GetUnicodeFont = UnicodeFont

    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.GetUnicodeFont"

End Function

Function Westernize(theValue As String) As String


    Dim Result1 As String
    Dim Result2 As String
    Dim StartPos As Integer
    Dim EndPos As Integer
    Dim CodeString As String
    Dim Code As Integer
    Dim Pre As String
    Dim Post As String
    
    Dim I As Integer
    Dim theChar As String
    
    On Error GoTo Abort
    
    Result1 = theValue
    EndPos = 1
    
    Do
        StartPos = InStr(EndPos, Result1, "&amp;#")
        If StartPos = 0 Then Exit Do
            
        EndPos = InStr(StartPos + 6, Result1, ";")
        If EndPos = 0 Then Exit Do
        
        CodeString = Mid$(Result1, StartPos + 6, EndPos - StartPos - 6)
        
        Pre = Mid$(Result1, 1, StartPos - 1)
        Post = Mid$(Result1, EndPos + 1, Len(Result1) - EndPos)
        
        Code = -1
        On Error Resume Next
        Code = Int(CodeString)
        On Error GoTo Abort
        
        Select Case Code
        
            Case -1
                Result1 = Pre + "?" + Post
                Common.DebugLog "Common.Decode, Unrecognized code = " + CodeString
                
            Case 256, 258, 260
                Result1 = Pre + "A" + Post
                
            Case 257, 259, 261
                Result1 = Pre + "a" + Post
                
            Case 262, 264, 266, 268
                Result1 = Pre + "C" + Post
                
            Case 263, 265, 267, 269
                Result1 = Pre + "c" + Post
                
            Case 270, 272
                Result1 = Pre + "D" + Post
            
            Case 271, 273
                Result1 = Pre + "d" + Post
                
            Case 274, 276, 278, 280, 282, 1028
                Result1 = Pre + "E" + Post
            
            Case 275, 277, 279, 281, 283, 1108
                Result1 = Pre + "e" + Post
                
            Case 284, 286, 288, 290
                Result1 = Pre + "G" + Post
            
            Case 285, 287, 289, 291
                Result1 = Pre + "g" + Post
                
            Case 292, 294
                Result1 = Pre + "H" + Post
                
            Case 293, 295
                Result1 = Pre + "h" + Post
                
            Case 298, 300, 302, 304, 1030, 1031
                Result1 = Pre + "I" + Post
                
            Case 299, 301, 303, 305, 1110, 1111
                Result1 = Pre + "i" + Post
                
            Case 308, 1032
                Result1 = Pre + "J" + Post
                
            Case 309, 1112
                Result1 = Pre + "j" + Post
                
            Case 310, 1036
                Result1 = Pre + "K" + Post
                
            Case 311, 1116
                Result1 = Pre + "k" + Post
                
            Case 313, 315, 317, 319, 321
                Result1 = Pre + "L" + Post
                
            Case 314, 316, 318, 320, 322
                Result1 = Pre + "l" + Post
                
            Case 323, 325, 327
                Result1 = Pre + "N" + Post
                
            Case 324, 326, 328
                Result1 = Pre + "n" + Post
                
            Case 332, 334, 336, 416
                Result1 = Pre + "O" + Post
                
            Case 333, 335, 337, 417
                Result1 = Pre + "o" + Post
                
            Case 340, 342, 344
                Result1 = Pre + "R" + Post
                
            Case 341, 343, 345
                Result1 = Pre + "r" + Post
                
            Case 346, 348, 350, 352, 536, 1029
                Result1 = Pre + "S" + Post
            
            Case 347, 349, 351, 353, 537, 1109
                Result1 = Pre + "s" + Post
                
            Case 354, 356, 538
                Result1 = Pre + "T" + Post
                
            Case 355, 357, 539
                Result1 = Pre + "t" + Post
                
            Case 362, 364, 366, 368, 370, 431
                Result1 = Pre + "U" + Post
            
            Case 363, 365, 367, 369, 371, 432
                Result1 = Pre + "u" + Post
                
            Case 372
                Result1 = Pre + "W" + Post
                
            Case 373
                Result1 = Pre + "w" + Post
                
            Case 374, 1038
                Result1 = Pre + "Y" + Post
                
            Case 375, 1118
                Result1 = Pre + "y" + Post
                
            Case 377, 379, 381
                Result1 = Pre + "Z" + Post
                
            Case 379, 380, 382
                Result1 = Pre + "z" + Post
                
            Case Else
                Result1 = Pre + Post
    
        End Select
        
        EndPos = StartPos
        
    Loop
    
    
    Result2 = ""
    For I = 1 To Len(Result1)
        
        theChar = Mid$(Result1, I, 1)
        Select Case Asc(theChar)
        
            Case 138
                Result2 = Result2 + "S"
                
            Case 140
                Result2 = Result2 + "Oe"
                
            Case 142
                Result2 = Result2 + "Z"
                
            Case 154
                Result2 = Result2 + "s"
                
            Case 156
                Result2 = Result2 + "oe"
                
            Case 158
                Result2 = Result2 + "z"
                
            Case 159
                Result2 = Result2 + "Y"
                
            Case Else
                Result2 = Result2 + theChar
        End Select
    
    Next I
    
    Westernize = Trim$(Result2)
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.Westernize"
    
End Function

Function IsPhoneMode(theMode As String) As Boolean

    On Error GoTo Abort
    
    IsPhoneMode = False
    
    Select Case LCase(theMode)
    
        Case "phone", "ssb", "lsb", "usb", "dsb", "am", "fm", "digvoice" 'DXKeeper 11.5.4 2013-12-27
            IsPhoneMode = True
    
    End Select
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.IsPhoneMode"
    
End Function

Function GetSignalReport(DefaultSignalReport As String, theMode As String) As String

    Dim TrimmedReport As String
    Dim SlashPos As Integer
    Dim PhoneReport As String
    Dim OtherReport As String
    
    On Error GoTo Abort
    
    
    TrimmedReport = Trim$(DefaultSignalReport)
    GetSignalReport = TrimmedReport
    
    SlashPos = InStr(DefaultSignalReport, "/")
    If SlashPos = 0 Then
        SlashPos = InStr(DefaultSignalReport, "\")
    End If
    If SlashPos = 0 Then
        GetSignalReport = TrimmedReport
    Else
        If SlashPos = 1 Then
            PhoneReport = ""
        Else
            PhoneReport = Mid$(DefaultSignalReport, 1, SlashPos - 1)
        End If
        
        If SlashPos = Len(TrimmedReport) Then
            OtherReport = ""
        Else
            OtherReport = Mid$(DefaultSignalReport, SlashPos + 1, Len(DefaultSignalReport) - SlashPos)
        End If
            
        If Common.IsPhoneMode(theMode) Then
            GetSignalReport = PhoneReport
        Else
            GetSignalReport = OtherReport
        End If
    
    End If
    
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetSignalReport"
End Function

Function GetIntegerSetting(AppName As String, SectionName As String, KeyName As String, DefaultValue As String) As Integer
    
    Dim theSetting As String
    Dim theResult As Integer
    
    On Error Resume Next
        
    theSetting = "~uninitialized~"
    theSetting = GetSetting(AppName, SectionName, KeyName, DefaultValue)
    If Err.Number > 0 Then
        theSetting = DefaultValue
    End If
    
    On Error GoTo Abort
    theResult = CInt(DefaultValue)
    On Error Resume Next
    theResult = CInt(theSetting)
    
    GetIntegerSetting = theResult
    
    If Common.GetDebug Then
        Common.Log "GetIntegerSetting, Section = " + SectionName + ", Key = " + KeyName + ", Result = " + Format$(theResult)
    End If
    
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetIntegerSetting, SectionName = " + SectionName + ", Key = " + KeyName + ", theSetting = " + theSetting + ", DefaultValue = " + DefaultValue
End Function

Function GetLongSetting(AppName As String, SectionName As String, KeyName As String, DefaultValue As String) As Long
    
    Dim theSetting As String
    Dim theResult As Long
    
    On Error Resume Next
        
    theSetting = "~uninitialized~"
    theSetting = GetSetting(AppName, SectionName, KeyName, DefaultValue)
    If Err.Number > 0 Then
        theSetting = DefaultValue
    End If
    
    On Error GoTo Abort
    theResult = CLng(DefaultValue)
    On Error Resume Next
    theResult = CLng(theSetting)
    
    GetLongSetting = theResult

    If Common.GetDebug Then
        Common.Log "GetLongSetting,    Section = " + SectionName + ", Key = " + KeyName + ", Result = " + Format$(theResult)
    End If
    
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetLongSetting, SectionName = " + SectionName + ", Key = " + KeyName + ", theSetting = " + theSetting + ", DefaultValue = " + DefaultValue
End Function

Function GetBooleanSetting(AppName As String, SectionName As String, KeyName As String, DefaultValue As String) As Boolean
    
    Dim theSetting As String
    Dim theResult As Boolean
    
    On Error Resume Next
        
    theSetting = "~uninitialized~"
    theSetting = GetSetting(AppName, SectionName, KeyName, DefaultValue)
    If Err.Number > 0 Then
        theSetting = DefaultValue
    End If
    
    On Error GoTo Abort
    theResult = CBool(DefaultValue)
    On Error Resume Next
    theResult = CBool(theSetting)
    
    GetBooleanSetting = theResult
    
    If Common.GetDebug Then
        Common.Log "GetBooleanSetting, Section = " + SectionName + ", Key = " + KeyName + ", Result = " + Format$(theResult)
    End If
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetBooleanSetting, SectionName = " + SectionName + ", Key = " + KeyName + ", theSetting = " + theSetting + ", DefaultValue = " + DefaultValue
End Function

Function GetSingleSetting(AppName As String, SectionName As String, KeyName As String, DefaultValue As String) As Single
    
    Dim theSetting As String
    Dim theResult As Single
    
    On Error Resume Next
        
    theSetting = "~uninitialized~"
    theSetting = GetSetting(AppName, SectionName, KeyName, DefaultValue)
    If Err.Number > 0 Then
        theSetting = DefaultValue
    End If
    
    On Error GoTo Abort
    theResult = CSng(DefaultValue)
    On Error Resume Next
    theResult = CSng(theSetting)
    
    GetSingleSetting = theResult
    
    If Common.GetDebug Then
        Common.Log "GetSingleSetting,  Section = " + SectionName + ", Key = " + KeyName + ", Result = " + Format$(theResult)
    End If
    
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetSingleSetting, SectionName = " + SectionName + ", Key = " + KeyName + ", theSetting = " + theSetting + ", DefaultValue = " + DefaultValue
End Function

Function GetDoubleSetting(AppName As String, SectionName As String, KeyName As String, DefaultValue As String) As Double
    
    Dim theSetting As String
    Dim theResult As Double
    
    On Error Resume Next
        
    theSetting = "~uninitialized~"
    theSetting = GetSetting(AppName, SectionName, KeyName, DefaultValue)
    If Err.Number > 0 Then
        theSetting = DefaultValue
    End If
    
    On Error GoTo Abort
    theResult = CDbl(DefaultValue)
    On Error Resume Next
    theResult = CDbl(theSetting)
    
    GetDoubleSetting = theResult
    
    If Common.GetDebug Then
        Common.Log "GetDoubleSetting,  Section = " + SectionName + ", Key = " + KeyName + ", Result = " + Format$(theResult)
    End If
    
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetDoubleSetting, SectionName = " + SectionName + ", Key = " + KeyName + ", theSetting = " + theSetting + ", DefaultValue = " + DefaultValue
End Function

Function GetDateSetting(AppName As String, SectionName As String, KeyName As String, DefaultValue As String) As Date
    
    Dim theSetting As String
    Dim theResult As Date
    
    On Error Resume Next
        
    theSetting = "~uninitialized~"
    theSetting = GetSetting(AppName, SectionName, KeyName, DefaultValue)
    If Err.Number > 0 Then
        theSetting = DefaultValue
    End If
    
    On Error GoTo Abort
    theResult = CDate(DefaultValue)
    On Error Resume Next
    theResult = CDate(theSetting)
    
    GetDateSetting = theResult
    
    If Common.GetDebug Then
        Common.Log "GetDateSetting,    Section = " + SectionName + ", Key = " + KeyName + ", Result = " + Format$(theResult)
    End If
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetDateSetting, SectionName = " + SectionName + ", Key = " + KeyName + ", theSetting = " + theSetting + ", DefaultValue = " + DefaultValue
End Function

Function GetStringSetting(AppName As String, SectionName As String, KeyName As String, DefaultValue As String) As String
    
    Dim theSetting As String
    
    On Error Resume Next
        
    theSetting = "~uninitialized~"
    theSetting = GetSetting(AppName, SectionName, KeyName, DefaultValue)
    If Err.Number > 0 Then
        theSetting = DefaultValue
    End If
    
    GetStringSetting = theSetting
    
    If Common.GetDebug Then
        Common.Log "GetstringSetting,  Section = " + SectionName + ", Key = " + KeyName + ", Result = " + theSetting
    End If
    
    Exit Function
Abort:

    Common.ProgramError Err.Number, "Common.GetStringSetting, SectionName = " + SectionName + ", Key = " + KeyName + ", theSetting = " + theSetting + ", DefaultValue = " + DefaultValue
End Function


Function ColorComponents(theColor As Long) As String
    
    Const HighMask = 255 * (2 ^ 16)
    Const MidMask = 255 * (2 ^ 8)
    Const LowMask = 255
    
    Dim Result As String
    
    On Error GoTo Abort
    
    Result = Format((theColor And HighMask) / 2 ^ 16)
    Result = Result + ", " + Format((theColor And MidMask) / 2 ^ 8)
    Result = Result + ", " + Format(theColor And LowMask)
    ColorComponents = Result
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.ColorComponents"
End Function

Function WPXPrefix(Fragment As String) As String
    
    Dim I As Integer
    Dim theChar As String
    Dim DigitPos As Integer
    
    On Error GoTo Abort
    
    WPXPrefix = ""
    
    If Len(Fragment) = 0 Then Exit Function
    
    DigitPos = -1
    
    For I = Len(Fragment) To 1 Step -1
        theChar = Mid$(Fragment, I, 1)
        
        If (theChar >= "0") And (theChar <= "9") Then
            If DigitPos = -1 Then
                DigitPos = I
            End If
        Else
            If DigitPos > 0 Then
                WPXPrefix = Mid$(Fragment, 1, DigitPos)
                If Len(WPXPrefix) > MaxWPX Then
                    WPXPrefix = Mid$(WPXPrefix, 1, MaxWPX)
                End If
                Exit Function
            End If
        End If
        
    Next I
    
    'no digit found
    If Len(Fragment) < 3 Then
        WPXPrefix = Fragment + "0"
    Else
        WPXPrefix = Mid$(Fragment, 1, 2) + "0"
    End If
    Exit Function

Abort: Common.ProgramError Err.Number, "Common.WPXPrefix"

End Function

Function RemoveBlanks(theData As String) As String

    Dim Result As String
    Dim I As Integer
    Dim char As String
    
    On Error GoTo Abort
    
    Result = ""
    
    For I = 1 To Len(theData)
        char = Mid$(theData, I, 1)
        If (char <> " ") And (Asc(char) <> 9) Then
            Result = Result + char
        End If
    Next I
    
    RemoveBlanks = Result
    Exit Function
    
Abort: Common.ProgramError Err.Number, "Common.RemoveBlanks"
    RemoveBlanks = ""
    
End Function

Function GetWPXPrefix(theCallsign As String) As String
    
    Dim Length As Integer
    Dim Slash1 As Integer
    Dim Slash2 As Integer

    Dim Part1 As String
    Dim Part2 As String
    Dim Part3 As String
    Dim RootPrefix As String
    Dim I As Integer
    Dim Candidate As String
    Dim Candidate2 As String
    Dim SubstitutionFlag As Boolean
    Dim Callsign As String
    
    
    On Error GoTo Abort
    
    GetWPXPrefix = ""
    
    Callsign = Common.RemoveBlanks(theCallsign)
    
    If Len(Callsign) = 0 Then Exit Function
    
    '6.8.1
    If Mid$(Callsign, 1, 1) = "!" Then
        Callsign = Mid$(Callsign, 2, Len(Callsign) - 1)
        If Len(Callsign) = 0 Then Exit Function
    End If
    
    Length = Len(Callsign)
    Slash1 = InStr(1, Callsign, "/")

    If Slash1 > 0 Then
        Part1 = Mid$(Callsign, 1, Slash1 - 1)
        Part2 = Mid$(Callsign, Slash1 + 1, Length - Slash1)

        Slash2 = InStr(1, Part2, "/")
        
        If Slash2 > 0 Then
            
            'three parts -- extract prefix from part1
            Part3 = Mid$(Part2, Slash2 + 1, Length - Slash2)
            Part2 = Mid$(Part2, 1, Slash2 - 1)
            
            Select Case LCase$(Part3)
            
                Case "b", "a", "m", "p"
                    GetWPXPrefix = Common.GetWPXPrefix(Part1 + "/" + Part2)
                
                Case Else
                    GetWPXPrefix = Common.WPXPrefix(Part1)
                        
            End Select
            
        ElseIf Len(Part2) = 1 Then
            
            'two parts, part2 is 1 character
            
            If (Part2 >= "0") And (Part2 <= "9") And (Slash1 > 3) Then '/N
                
                'substitute number in part1
                SubstitutionFlag = False
                For I = 2 To Slash1 - 1
                    Candidate = Mid$(Part1, I, 1)
                    If (Candidate >= "0") And (Candidate <= "9") Then
                        '10.3.5 if 2nd and 3rd characters are both numbers, replace 3d character
                        If (I = 2) And (Slash1 > 3) Then
                            Candidate2 = Mid$(Part1, 3, 1)
                            If (Candidate2 >= "0") And (Candidate2 <= "9") Then
                                Mid$(Part1, 3, 1) = Part2  ' third character is a number; substitute N
                                SubstitutionFlag = True
                                Exit For
                            End If
                        End If
                        
                        Mid$(Part1, I, 1) = Part2  ' substitute N
                        SubstitutionFlag = True
                        Exit For
                    End If
                Next I
                
                If SubstitutionFlag Then
                    GetWPXPrefix = Common.WPXPrefix(Part1)
                Else
                    If Len(Part1) > 1 Then
                        GetWPXPrefix = Common.WPXPrefix(Mid$(Part1, 1, 2) + Part2 + Mid$(Part1, 3, Len(Part1) - 2))
                    Else
                        GetWPXPrefix = Part1 + Part2
                    End If
                End If
                
            Else
                'part2 is a single non-numeric character
                GetWPXPrefix = Common.WPXPrefix(Part1)
            End If

        ElseIf (Len(Part2) = 2) Then
        
            If LCase$(Part2) = "mm" Then
                GetWPXPrefix = Common.WPXPrefix(Part1)
                
            ElseIf LCase$(Part2) = "am" Then
                GetWPXPrefix = Common.WPXPrefix(Part1)
                
            ElseIf LCase$(Part2) = "ag" Then
                GetWPXPrefix = Common.WPXPrefix(Part1)
                
            ElseIf LCase$(Part2) = "aa" Then
                GetWPXPrefix = Common.WPXPrefix(Part1)
                
            ElseIf LCase$(Part2) = "ae" Then
                GetWPXPrefix = Common.WPXPrefix(Part1)
            Else
                If Common.IsInteger(Part2) Then
                    GetWPXPrefix = Common.WPXPrefix(Part1)
                Else
                    GetWPXPrefix = Common.WPXPrefix(Part2)
                End If
            End If
            
        ElseIf (Len(Part2) = 3) Then
            
            If (LCase$(Part2)) = "qrp" Then
                GetWPXPrefix = Common.WPXPrefix(Part1)
            
            ElseIf LCase$(Mid$(Part2, Len(Part2) - 2, 2)) = "mm" Then
                If Common.IsDigit(Mid$(Part2, Len(Part2), 1)) Then
                    GetWPXPrefix = Common.WPXPrefix(Part1)
                Else
                    GetWPXPrefix = Common.WPXPrefix(Part2)
                End If
                
            ElseIf LCase$(Mid$(Part2, Len(Part2) - 2, 2)) = "am" Then
                If Common.IsDigit(Mid$(Part2, Len(Part2), 1)) Then
                    GetWPXPrefix = Common.WPXPrefix(Part1)
                Else
                    GetWPXPrefix = Common.WPXPrefix(Part2)
                End If
                
            Else
                If Common.IsInteger(Part2) Then
                    GetWPXPrefix = Common.WPXPrefix(Part1)
                Else
                    GetWPXPrefix = Common.WPXPrefix(Part2)
                End If
            End If
            
        ElseIf (Len(Part2) = 6) And (LCase$(Part2)) = "mobile" Then
            GetWPXPrefix = Common.WPXPrefix(Part1)
            
        ElseIf Len(Part1) <= Len(Part2) Then
            GetWPXPrefix = Common.WPXPrefix(Part1)
        
        Else
            If Common.IsInteger(Part2) Then
                GetWPXPrefix = Common.WPXPrefix(Part1)
            Else
                GetWPXPrefix = Common.WPXPrefix(Part2)
            End If
        
        End If
    Else
        GetWPXPrefix = Common.WPXPrefix(Callsign)
    End If

    Exit Function

Abort: Common.ProgramError Err.Number, "Common.GetWPXPrefix"

End Function

Function SelectAntennaDescription(theDescription As String, theBand As String)
    Dim StartPos As Long
    Dim EndPos As Long
    Dim LowerDescription
    Dim StartTag As String
    
    On Error GoTo Abort
    
    SelectAntennaDescription = ""
    If Len(Trim(theBand)) = 0 Then Exit Function
    
    LowerDescription = LCase$(theDescription)
    
    StartTag = "[ant" + LCase$(theBand) + ":"
    StartPos = InStr(LowerDescription, StartTag)
    If StartPos > 0 Then
        EndPos = InStr(StartPos + Len(StartTag), LowerDescription, "]")
        If EndPos > 0 Then
            SelectAntennaDescription = Trim$(Mid$(theDescription, StartPos + Len(StartTag), EndPos - StartPos - Len(StartTag)))
        End If
    End If
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "Common.SelectAntennaDescription"

End Function


