Attribute VB_Name = "DDECommon"
Option Explicit

Global Const DefaultDDETimeout = 50 '5 seconds

'server Identifiers
Global Const XcvrControlServer = 0
Global Const LogServer = 1
Global Const QSLInfoServer = 2
Global Const DXViewServer = 3
Global Const SpotServer = 4
Global Const PropServer = 5
Global Const ModeServer = 6

Global Const FirstServer = XcvrControlServer
Global Const LastServer = ModeServer

Global Const UnknownSideband = -1

Global Const LSBmode = 0
Global Const USBMode = 1
Global Const AMMode = 2
Global Const CWMode = 3
Global Const RTTYMode = 4
Global Const fmMode = 5
Global Const WBFMMode = 6
Global Const CWRMode = 7
Global Const RTTYRMode = 8
Global Const PKTMode = 9
Global Const PKTRMode = 10
Global Const UnknownMode = 11

Global Const FirstMode = LSBmode
Global Const LastMode = PKTRMode

Global Const RTTYSubModeUnknown = -1
Global Const RTTYSubModeFSK = 0
Global Const RTTYSubModeAFSK = 1
    
Global Const RotateNone = 0
Global Const RotateSP = vbCtrlMask
Global Const RotateLP = vbAltMask

Global Const SpotUnknown = -3 '6.7.2
Global Const SpotSpecialCallsign = -2
Global Const SpotCountryUnworked = -1
Global Const SpotUnworked = 0
Global Const SpotUnconfirmed = 1
Global Const SpotConfirmed = 2
Global Const SpotVerified = 3

'Spot constants
Global Const ClusterSpot = 0
Global Const LocalSpot = 1

'Commander CW Capability
Global Const CWNone = "0"
Global Const CWElements = "1"
Global Const CWCharacters = "2"

'Overide constants used by DXView and SpotCollector
Global Const OverideParamClear = -1
Global Const OverideParamCallsign = 0
Global Const OverideParamDXCC = 1
Global Const OverideParamCQ = 2
Global Const OverideParamITU = 3
Global Const OverideParamLocation = 4
Global Const OverideParamGrid = 5
Global Const OverideParamIOTA = 6
Global Const OverideParamCont = 7
Global Const OverideParamTime = 8
Global Const OverideParamExpiration = 9

'Universal commands"
Global Const ShutdownCommand = "shutdown"
Global Const TestCommand = "test"
Global Const IconifyCommand = "iconify"
Global Const ActivateCommand = "activate"
Global Const ResetWindowsCommand = "resetwindows"

'Universal server commands
Global Const StartCommand = "start"
Global Const StopCommand = "stop"

'WinWarbler commands
'Global Const NewSpotColorsCommand = "newspotcolors" 'defined in Commander
Global Const SetSCMinFreqModeCommand = "setscminfreqmode"
    Global Const SCFreq = "scfreq"
    Global Const SCFreqPos = 1
    Global Const SCQSX = "scqsx"
    Global Const SCQSXPos = 2
    Global Const SCMode = "scmode"
    Global Const SCModePos = 3

Global Const SetSCFreqModeCommand = "setscfreqmode"
    'Global Const SCFreq = "scfreq"
    'Global Const SCFreqPos = 1
    'Global Const SCQSX = "scqsx"
    'Global Const SCQSXPos = 2
    'Global Const SCMode = "scmode"
    'Global Const SCModePos = 3
    Global Const SCCall = "sccall"
    Global Const SCCallPos = 4

Global Const SetSCNewEntryCommand = "setscnewentry"
    'Global Const SCFreq = "scfreq"
    'Global Const SCFreqPos = 1
    'Global Const SCQSX = "scqsx"
    'Global Const SCQSXPos = 2
    'Global Const SCMode = "scmode"
    'Global Const SCModePos = 3
    'Global Const SCCall = "sccall"
    'Global Const SCCallPos = 4
    Global Const SCLogMode = "logmode"
    Global Const SCLogModePos = 5
    Global Const SCRotate = "rotate"
    Global Const SCRotatePos = 6
    Global Const SCSearch = "logfilter"
    Global Const SCSearchPos = 7
    Global Const SCPrefix = "prefix"
    Global Const SCPrefixPos = 8
    Global Const SCGrid = "grid"
    Global Const SCGridPos = 9
    Global Const SCSubmode = "scsubmode"
    Global Const SCSubmodePos = 10
    Global Const SCCQ = "cq"
    Global Const SCCQPos = 11
    Global Const SCITU = "itu"
    Global Const SCITUPos = 12
    Global Const SCIOTA = "iota"
    Global Const SCIOTAPos = 13
    Global Const SCPrimary = "primary"
    Global Const SCPrimaryPos = 14
    Global Const SCRegion = "region"
    Global Const SCRegionPos = 15
    Global Const SCCont = "continent"
    Global Const SCContPos = 16
    Global Const SCTags = "tags"
    Global Const SCTagsPos = 17
    Global Const SCNpota = "npota"
    Global Const SCNpotaPos = 18
    
Global Const InvokeMacroCommand = "invokemacro"

Global Const ConveyUDFParameterCommand = "conveyudfparameter"
    Global Const UDFParameterName = "udfparametername"
    Global Const UDFParameterNamePos = 1
    Global Const UDFParameterValue = "udfparametervalue"
    Global Const UDFParameterValuePos = 2

Global Const ConveyAllUDFParametersCommand = "conveyalludfparameters"

Global Const ConveyQSLMsgCommand = "conveyqslmsg"
    Global Const QSLMsgIndex = "qslmsgindex"
    Global Const QSLMsgIndexPos = 1
    Global Const QSLMsgValue = "qslmsgvalue"
    Global Const QSLMsgValuePos = 2

Global Const DisplayReceivedCW = "displaycw"

Global Const DisplayReceivedRTTY = "displayrtty"

Global Const SetWWCallCommand = "setwwcall"

Global Const StartWWLookupCommand = "startwwlookup"

    
'Pathfinder commands
Global Const GetQSLInfoCommand = "getqslinfo"
    Global Const QSLCallsign = "callsign"
    Global Const QSLCallsignPos = 1
Global Const GetCallbookInfoCommand = "getcallbookinfo"
    Global Const CallbookName = "callbookname"
    Global Const CallbookNamePos = 1
    Global Const CallbookCallsign = "callbookcallsign"
    Global Const CallbookCallsignPos = 2
    
    
'CI-V Commander commands
Global Const TransmitCommand = "transmit"

Global Const ReceiveCommand = "receive"

Global Const QSYCommand = "qsy"

Global Const SetRXFreqCommand = "setrxfreq"

Global Const SetTXFreqCommand = "settxfreq"

Global Const MonoSplitCommand = "monosplit" 'Commander 10.6.1

Global Const BandspreadBandCommand = "bandspreadband"

Global Const SetVFOACommand = "setvfoa"

Global Const SetVFOBCommand = "setvfob"

Global Const SetVFOEqualCommand = "setvboequal"

Global Const SetVFOSwapCommand = "setvfoswap"

Global Const SetFilterCommand = "setfilter"

Global Const SetSplitCommand = "setsplit"

Global Const SetDualCommand = "setdual"

Global Const SyncIcomCommand = "syncicom"

Global Const SendNamedUserSequenceCommand = "seqname"

Global Const SendIndexedUserSequenceCommand = "seqindex"

Global Const SendXcvrCommand = "xcvrcommand"

Global Const SetUserCommandSequenceName = "setusercmdname"
    Global Const UserCmdNumber = "usercmdnumber"
    Global Const UserCmdNumberPos = 1
    Global Const UserCmdName = "usercmdname"
    Global Const UserCmdNamePos = 2
    
Global Const SetUserCommandSequenceLEDColor = "setusercmdledcolor"
    'Global Const UserCmdNumber = "usercmdnumber"
    'Global Const UserCmdNumberPos = 1
    Global Const UserCmdLEDColor = "usercmdledcolor"
    Global Const UserCmdLEDColorPos = 2
    
Global Const XCVRFreqModeCommand = "xcvrfreqmode"
    Global Const XcvrFreq = "xcvrfreq"
    Global Const XcvrFreqPos = 1
    Global Const XcvrMode = "xcvrmode"
    Global Const XcvrModePos = 2
    Global Const XcvrPreserveSplitAndDual = "preservesplitanddual"  'optional, defaults to "clear split and dual"
    Global Const XcvrPreserveSplitAndDualPos = 3
    
Global Const SplitCommand = "split"
    'Global Const XcvrFreq = "xcvrfreq"
    'Global Const XcvrFreqPos = 1
    Global Const XcvrSuppressDual = "suppressdual"
    Global Const XcvrSuppressDualPos = 2
    Global Const XcvrSuppressModeChange = "suppressmodechange" 'optional, defaults to "change TX VFO mode"
    Global Const XcvrSuppressModeChangePos = 3
    
Global Const XCVRSetModeCommand = "xcvrsetmodecmd"
    Global Const XcvrSetMode = "xcvrsetmodearg"
    Global Const XCVRSetModePos = 1

Global Const SetSliderCommand = "setslidercmd"
    Global Const SetSliderId = "setsliderId"
    Global Const SetSliderIDPos = 1
    Global Const SetSliderValue = "setslidervalue"
    Global Const SetSliderValuePos = 2

Global Const ClearSpotsCommand = "clearspots"

Global Const UpdateSpotsCommand = "updatespots"
    Global Const UpdateSpotsPrefix = "prefix"
    Global Const UpdateSpotsPrefixPos = 1
    Global Const UpdateSpotsBand = "band"
    Global Const UpdateSpotsBandPos = 2
    Global Const UpdateSpotsMode = "mode"
    Global Const UpdateSpotsModePos = 3
    Global Const UpdateSpotsOrigin = "origin"
    Global Const UpdateSpotsOriginPos = 4
    Global Const UpdateSpotsCall = "call"
    Global Const UpdateSpotsCallPos = 5
    Global Const UpdateSpotsFreq = "freq"
    Global Const UpdateSpotsFreqPos = 6
    Global Const UpdateSpotsTime = "time"
    Global Const UpdateSpotsTimePos = 7
    Global Const UpdateSpotsIndex = "index"
    Global Const UpdateSpotsIndexPos = 8
    Global Const UpdateSpotsDXGrid = "dxgrid"
    Global Const UpdateSpotsDXGridPos = 9
    Global Const UpdateSpotsOriginGrid = "origingrid"
    Global Const UpdateSpotsOriginGridPos = 10
    Global Const UpdateSpotsCountry = "country"
    Global Const UpdateSpotsCountryPos = 11
    Global Const UpdateSpotsNeed = "need"
    Global Const UpdateSpotsNeedPos = 12
    Global Const UpdateSpotsColor = "color"
    Global Const UpdateSpotsColorPos = 13
    Global Const UpdateSpotsNotes = "notes"
    Global Const UpdateSpotsNotesPos = 14
    Global Const UpdateSpotsKind = "kind"
    Global Const UpdateSpotsKindPos = 15
    Global Const UpdateSpotsQSX = "QSX"
    Global Const UpdateSpotsQSXPos = 16
    Global Const UpdateSpotsLotW = "LOTW"
    Global Const UpdateSpotsLotWPos = 17
    Global Const UpdateSpotsLotWColor = "LOTWColor"
    Global Const UpdateSpotsLotWColorPos = 18
    Global Const UpdateSpotseQSL = "EQSL"
    Global Const UpdateSpotseQSLPos = 19
    Global Const UpdateSpotseQSLColor = "EQSLColor"
    Global Const UpdateSpotseQSLColorPos = 20
    Global Const UpdateSpotsLotWeQSLColor = "LOTWEQSLColor"
    Global Const UpdateSpotsLotWeQSLColorPos = 21
    Global Const UpdateSpotsLocal = "localspot"
    Global Const UpdateSpotsLocalPos = 22
    
Global Const NewSpotColorsCommand = "newspotcolors"

Global Const CWCharsCommand = "cwchars"

Global Const CWSpeedCommand = "cwspeed"

Global Const CWClearCommand = "cwclear"

Global Const CWKeyOnCommand = "cwkeyon"

Global Const CWKeyOffCommand = "cwkeyoff"

Global Const CWTuneOnCommand = "cwtuneon"

Global Const CWAbortCommand = "cwabort"

Global Const RTTYStopCommand = "rttystop"

Global Const BandspreadFocusCommand = "bandspreadfocus"

Global Const SelectPrimaryXcvrCommand = "selectprimary"
    
    
'DXView commands
'Global Const NewAwardsCommand = "newawards"  'same command defined for SpotCollector
Global Const LookupCommand = "lookup"
    
Global Const PrefixLookupCommand = "prefixlookup"
    Global Const PrefixLookupPrefix = "prefix"
    Global Const PrefixLookupPrefixPos = 1
    Global Const PrefixLookupCall = "call"
    Global Const PrefixLookupCallPos = 2
    Global Const PrefixLookupIgnorable = "ignorable"
    Global Const PrefixLookupIgnorablePos = 3
    Global Const PrefixLookupUpdateMapInfo = "updatemapinfo"
    Global Const PrefixLookupUpdateMapInfoPos = 4
    
Global Const AsyncPrefixLookupCommand = "asyncprefixlookup"
    'Global Const PrefixLookupPrefix = "prefix"
    'Global Const PrefixLookupPrefixPos = 1
    'Global Const PrefixLookupCall = "call"
    'Global Const PrefixLookupCallPos = 2
    'Global Const PrefixLookupIgnorable = "ignorable"
    'Global Const PrefixLookupIgnorablePos = 3
    Global Const AsyncPrefixLookupGrid = "grid"
    Global Const AsyncPrefixLookupGridPos = 4
    
Global Const DatabaseUpgradeCommand = "databaseupgrade"

Global Const SpotLookupCommand = "spotlookup"

Global Const ShowGridCommand = "showgrid"

Global Const UpdateWithGridCommand = "updatewithgrid"

Global Const UpdateWithCoordCommand = "updatewithcoord"  'DXView 3.8.0
    Global Const UpdateWithCoordLat = "lat"
    Global Const UpdateWithCoordLatPos = 1
    Global Const UpdateWithCoordLon = "lon"
    Global Const UpdateWithCoordLonPos = 2

Global Const GetDXCCPrefixCommand = "getprefix"

Global Const ClearSpotTableCommand = "clearspots"

Global Const SelectPositionCommand = "selectposition"
    Global Const SelectPositionLat = "lat"
    Global Const SelectPositionLatPos = 1
    Global Const SelectPositionLon = "lon"
    Global Const SelectPositionLonPos = 2

Global Const SelectQTHCommand = "selectqth"
    Global Const SelectQTHLat = "lat"
    Global Const SelectQTHLatPos = 1
    Global Const SelectQTHLon = "lon"
    Global Const SelectQTHLonPos = 2
    Global Const SelectQTHArea = "area"
    Global Const SelectQTHAreaPos = 3

Global Const SelectBearingCommand = "selectbearing"

Global Const RotateSPCommand = "rotatesp"

Global Const RotateLPCommand = "rotatelp"

Global Const NewLogCommand = "newlog"

Global Const OpenSpecialCallDatabaseCommand = "openspecial" 'DXView 3.8.5

Global Const CloseSpecialCallDatabaseCommand = "closespecial" 'DXView 3.8.5

Global Const UpdateStatusCommand = "updatestatus"
    Global Const UpdateStatusDXCCID = "dxccid"
    Global Const UpdateStatusDXCCIDPos = 1
    Global Const UpdateStatusString = "string"
    Global Const UpdateStatusStringPos = 2

Global Const UpdateLogFilterCommand = "updatelogfilter"

Global Const ClearLoggedQSOsCommand = "clearloggedqsos"

Global Const DisplayLoggedQSOsCommand = "displayloggedqsos"

Global Const CompleteLoggedQSOsCommand = "completeloggedqsos"

Global Const PlotDXCCPrefixCommand = "plotprefix"

Global Const PlotCallCommand = "plotcall"

Global Const PlotGridCommand = "plotgrid"

Global Const PlotFullPrefixCommand = "plotfullprefix"
    Global Const PlotFullPrefix = "prefix"
    Global Const PlotFullPrefixPos = 1
    Global Const PlotFullPrefixBand = "band"
    Global Const PlotFullPrefixBandPos = 2
    Global Const PlotFullPrefixMode = "mode"
    Global Const PlotFullPrefixModePos = 3
    Global Const PlotFullPrefixOrigin = "origin"
    Global Const PlotFullPrefixOriginPos = 4

Global Const PlotFullCallCommand = "plotfullcall"
    Global Const PlotFullCallPrefix = "prefix"
    Global Const PlotFullCallPrefixPos = 1
    Global Const PlotFullCallBand = "band"
    Global Const PlotFullCallBandPos = 2
    Global Const PlotFullCallMode = "mode"
    Global Const PlotFullCallModePos = 3
    Global Const PlotFullCallOrigin = "origin"
    Global Const PlotFullCallOriginPos = 4
    Global Const PlotFullCall = "call"
    Global Const PlotFullCallPos = 5
    Global Const PlotFullCallFreq = "freq"
    Global Const PlotFullCallFreqPos = 6
    Global Const PlotFullCallTime = "time"
    Global Const PlotFullCallTimePos = 7
    Global Const PlotFullCallIndex = "index"
    Global Const PlotFullCallIndexPos = 8
    Global Const PlotFullCallDXGrid = "dxgrid"
    Global Const PlotFullCallDXGridPos = 9
    Global Const PlotFullCallOriginGrid = "origingrid"
    Global Const PlotFullCallOriginGridPos = 10
    Global Const PlotFullCallQSX = "qsx"
    Global Const PlotFullCallQSXPos = 11
    Global Const PlotFullCallSpotter = "spotter"
    Global Const PlotFullCallSpotterPos = 12

Global Const PlotLoggedQSOCommand = "plotloggedqso"
    Global Const PlotLoggedQSOPrefix = "prefix"
    Global Const PlotLoggedQSOPrefixPos = 1
    Global Const PlotLoggedQSOBand = "band"
    Global Const PlotLoggedQSOBandPos = 2
    Global Const PlotLoggedQSOMode = "mode"
    Global Const PlotLoggedQSOModePos = 3
    Global Const PlotLoggedQSOCall = "call"
    Global Const PlotLoggedQSOCallPos = 4
    Global Const PlotLoggedQSOFreq = "freq"
    Global Const PlotLoggedQSOFreqPos = 5
    Global Const PlotLoggedQSOGrid = "grid"
    Global Const PlotLoggedQSOGridPos = 6
    Global Const PlotLoggedQSOProgress = "progress"
    Global Const PlotLoggedQSOProgressPos = 7
    Global Const PlotLoggedQSOGridProgress = "gridprogress"
    Global Const PlotLoggedQSOGridProgressPos = 8
    
Global Const UpdateoverideCallCommand = "updateoveridecall"
    Global Const UpdateoverideCallIndex = "index"
    Global Const UpdateoverideCallIndexPos = 1
    Global Const UpdateoverideCallValue = "callsign"
    Global Const UpdateoverideCallValuePos = 2
    
Global Const UpdateOverideEntityCommand = "updateoverideentity"
    Global Const UpdateOverideEntityIndex = "index"
    Global Const UpdateOverideEntityIndexPos = 1
    Global Const UpdateOverideEntityValue = "entity"
    Global Const UpdateOverideEntityValuePos = 2
    Global Const UpdateOverideEntityPopulate = "populate"
    Global Const UpdateOverideEntityPopulatePos = 3

Global Const UpdateOverideParamCommand = "updateoverideparam"
    Global Const UpdateOverideParamIndex = "index"
    Global Const UpdateOverideParamIndexPos = 1
    Global Const UpdateOverideParamID = "id"
    Global Const UpdateOverideParamIDPos = 2
    Global Const UpdateOverideParamValue = "value"
    Global Const UpdateOverideParamValuePos = 3

Global Const BeaconLookupCommand = "beaconlookup"
    Global Const BeaconLookupCall = "call"
    Global Const BeaconLookupCallPos = 1
    Global Const BeaconLookupLat = "lat"
    Global Const BeaconLookupLatPos = 2
    Global Const BeaconLookupLon = "lon"
    Global Const BeaconLookupLonPos = 3
    Global Const BeaconLookupQTH = "qth"
    Global Const BeaconLookupQTHPos = 4
    Global Const BeaconLookupPrefix = "prefix"
    Global Const BeaconLookupPrefixPos = 5
    Global Const BeaconLookupCountry = "country"
    Global Const BeaconLookupCountryPos = 6
    Global Const BeaconLookupCont = "cont"
    Global Const BeaconLookupContPos = 7
    Global Const BeaconLookupCQ = "cq"
    Global Const BeaconLookupCQPos = 8
    Global Const BeaconLookupITU = "itu"
    Global Const BeaconLookupITUPos = 9
    Global Const BeaconLookupTimeZone = "timezone"
    Global Const BeaconLookupTimeZonePos = 10
   
Global Const MultiLookupCommand = "multilookup"
    Global Const MultiLookupEnabled = "active"
    Global Const MultiLookupPos = 1
    
Global Const NewOpModeCommand = "newopmode"
    Global Const NewOpModeArg = "opmode"
    Global Const NewOpModeArgPos = 1

'DXKeeper commands
'Global Const NewSpotColorsCommand = "newspotcolors" 'defined in Commander

Global Const LogCommand = "log"

Global Const eQSLLogCommand = "eqsllog"

Global Const LoTWLogCommand = "lotwlog"

Global Const eQSLLoTWLogCommand = "eqsllotwlog"

Global Const DeleteQSOCommand = "deleteqso"

Global Const CheckCommand = "check"

Global Const GetProgressCommand = "getprogress"
    Global Const ProgressPrefix = "ProgressPrefix"
    Global Const ProgressPrefixPos = 1
    Global Const ProgressBand = "ProgressBand"
    Global Const ProgressBandPos = 2
    Global Const ProgressMode = "ProgressMode"
    Global Const ProgressModePos = 3

Global Const NewCallsignCommand = "newcallsign"
    Global Const NewCallsign = "callsign"
    Global Const NewCallsignPos = 1
    Global Const NewCallsignRotate = "rotate"
    Global Const NewCallsignRotatePos = 2
    Global Const NewCallsignPrefix = "prefix"
    Global Const NewCallsignPrefixPos = 3

Global Const NewEntryCommand = "newentry"
    Global Const NewEntryCallsign = "entrycallsign"
    Global Const NewEntryCallsignPos = 1
    Global Const NewEntryFreq = "entryfreq"
    Global Const NewEntryFreqPos = 2
    Global Const NewEntryMode = "entrymode"
    Global Const NewEntryModePos = 3
    Global Const NewEntryRotate = "rotate"
    Global Const NewEntryRotatePos = 4
    Global Const NewEntrySearch = "logfilter"
    Global Const NewEntrySearchPos = 5
    Global Const NewEntryPrefix = "prefix"
    Global Const NewEntryPrefixPos = 6
    Global Const NewEntryGrid = "grid"
    Global Const NewEntryGridPos = 7
    Global Const NewEntrySuppressOverwriteCheck = "Suppress"
    Global Const NewEntrySuppressOverwriteCheckPos = 8
    Global Const NewEntryCQ = "cq"
    Global Const NewEntryCQPos = 9
    Global Const NewEntryITU = "itu"
    Global Const NewEntryITUPos = 10
    Global Const NewEntryIOTA = "iota"
    Global Const NewEntryIOTAPos = 11
    Global Const NewEntryPrimary = "primary"
    Global Const NewEntryPrimaryPos = 12
    Global Const NewEntryAppSource = "appsource"
    Global Const NewEntryAppSourcePos = 13
    Global Const NewEntryRegion = "region"
    Global Const NewEntryRegionPos = 14
    Global Const NewEntryCont = "continent"
    Global Const NewEntryContPos = 15
    Global Const NewEntryTags = "tags"
    Global Const NewEntryTagsPos = 16
    Global Const NewEntryNpota = "npota"
    Global Const NewEntryNpotaPos = 17

Global Const ShowProgressCommand = "showprogress"
    Global Const ShowProgressCallsign = "ShowProgressCallsign"
    Global Const ShowProgressCallsignPos = 1
    Global Const ShowProgressDXCCID = "ShowProgressDXCCID"
    Global Const ShowProgressDXCCIDPos = 2
    Global Const ShowProgressPrefix = "ShowProgressPrefix"
    Global Const ShowProgressPrefixPos = 3
    Global Const ShowProgressCQZone = "ShowProgressCQZone"
    Global Const ShowProgressCQZonePos = 4
    Global Const ShowProgressRegion = "ShowProgressRegion"
    Global Const ShowProgressRegionPos = 5
    Global Const ShowProgressIOTA = "ShowProgressIOTA"
    Global Const ShowProgressIOTAPos = 6
    Global Const ShowProgressVUCC = "ShowProgressVUCC" 'DXK 11.4.0
    Global Const ShowProgressVUCCPos = 7
    Global Const ShowProgressWAS = "ShowProgressWAS" 'DXK 11.4.0
    Global Const ShowProgressWASPos = 8
    Global Const ShowProgressWPX = "ShowProgressWPX" 'DXK 11.4.0
    Global Const ShowProgressWPXPos = 9
    
'DXKeeper accepts this command defined in DXView's command section
'Global Const UpdateOverideParamCommand = "updateoverideparam"
'    Global Const UpdateOverideParamIndex = "index"
'    Global Const UpdateOverideParamIndexPos = 1
'    Global Const UpdateOverideParamID = "id"
'    Global Const UpdateOverideParamIDPos = 2
'    Global Const UpdateOverideParamValue = "value"
'    Global Const UpdateOverideParamValuePos = 3
    
Global Const TrackWarblerFreqCommand = "trackwarblerfreq"

Global Const SearchCallbookCommand = "searchcallbook"
    Global Const CallbookDisabledResponse = "***disabled***"

Global Const ClearCaptureCommand = "clearcapture"

Global Const InitializeCaptureCommand = "initializecapture"

Global Const FilterLogCommand = "filterlog"
    Global Const FilterLogExpression = "filterexpression"
    Global Const FilterLogExpressionPos = 1
    Global Const FilterLogCaption = "filtercaption"
    Global Const FilterLogCaptionPos = 2
    Global Const FilterLogTextbox = "filtertextbox"  'optional
    Global Const FilterLogTextboxPos = 3

Global Const ProgressFilterCommand = "progressfilter"
    Global Const ProgressFilterDXCCPrefix = "progressfilterdxccprefix"
    Global Const ProgressFilterDXCCPrefixPos = 1
    Global Const ProgressFilterBandColumn = "progressfilterbandcolumn"
    Global Const ProgressFilterBandColumnPos = 2
    Global Const ProgressFilterModeRow = "progressfiltermoderow"
    Global Const ProgressFilterModeRowPos = 3

Global Const ImportCommand = "import"

Global Const AddRequestedCommand = "addrequested"

Global Const CommandInProgressCommand = "commandinprogress"

Global Const CommandCompleteCommand = "commandcomplete"

Global Const OpenLastLogCommand = "openlastlog"

Global Const CloseLogCommand = "closelog"

Global Const ShowConfigTabCommand = "showconfigtab"

Global Const UpdateCaptureItemCommand = "updatecaptureitem"
    Global Const UpdateCaptureItemName = "updatecaptureitemname"
    Global Const UpdateCaptureItemNamePos = 1
    Global Const UpdateCaptureItemValue = "updatecaptureitemvalue"
    Global Const UpdateCaptureItemValuePos = 2

Global Const SelectQTHIDCommand = "selectqthid"

'record conveyed via DDEServer.MyQTHInfo
    Global Const MyQTHInfoCity = "MyQTHInfoCity"
    Global Const MyQTHInfoCityPos = 1
    Global Const MyQTHInfoPrimary = "MyQTHInfoPrimary"
    Global Const MyQTHInfoPrimaryPos = 2
    Global Const MyQTHInfoSecondary = "MyQTHInfoSecondary"
    Global Const MyQTHInfoSecondaryPos = 3
    Global Const MyQTHInfoCQ = "MyQTHInfoCQ"
    Global Const MyQTHInfoCQPos = 4
    Global Const MyQTHInfoITU = "MyQTHInfoITU"
    Global Const MyQTHInfoITUPos = 5
    Global Const MyQTHInfoIOTA = "MyQTHInfoIOTA"
    Global Const MyQTHInfoIOTAPos = 6
    Global Const MyQTHInfoRig = "MyQTHinfoRig"
    Global Const MyQTHInfoRigPos = 7
    Global Const MyQTHInfoAnt = "MyQTHInfoAnt"
    Global Const MyQTHInfoAntPos = 8
    
Global Const OpenOverrideDatabaseCommand = "openoverride" '2017-04-15

Global Const CloseOverrideDatabaseCommand = "closeoverride" '2017-04-15


'PropView commands
Global Const NewWWVCommand = "newwwv"
    Global Const NewDate = "NewDate"
    Global Const NewDatePos = 1
    Global Const NewSFI = "NewSFI"
    Global Const NewSFIPos = 2
    Global Const NewA = "NewA"
    Global Const NewAPos = 3
    Global Const NewK = "NewK"
    Global Const NewKPos = 4

Global Const SetPowerCommand = "setpower"

Global Const Predictcommand = "predict"

Global Const PredictSPcommand = "predsp"

Global Const PredictLPcommand = "predlp"

Global Const PredictFreqModePathCommand = "predfmp"
    Global Const fmpFreq = "PredictFreq"
    Global Const fmpFreqPos = 1
    Global Const fmpMode = "PredictMode"
    Global Const fmpModePos = 2
    Global Const fmpPath = "PredictPath"
    Global Const fmpPathPos = 3
    Global Const fmpDefaultSNR = "PredictDefaultSNR"
    Global Const fmpDefaultSNRPos = 4
    Global Const fmpResults = "PredictResults"
    Global Const fmpResultsPos = 5

Global Const RequestSNRForecastCommand = "reqsnr"
    Global Const ReqSNRFreq = "ReqSNRFreq"
    Global Const ReqSNRFreqPos = 1
    Global Const ReqSNRMode = "ReqSNRMode"
    Global Const ReqSNRModePos = 2
    Global Const ReqSNRDefault = "ReqSNRDefaultSNR"
    Global Const ReqSNRDefaultPos = 3
    Global Const ReqSNRGrid = "ReqSNRGrid"
    Global Const ReqSNRGridPos = 4


'SpotCollector commands

Global Const NewAwardsCommand = "newawards"

Global Const UpdateProgressCommand = "updateprogress"
    Global Const UpdatedCallsign = "UpdatedCallsign"
    Global Const UpdatedCallsignPos = 1
    Global Const UpdatedBand = "UpdatedBand"
    Global Const UpdatedBandPos = 2
    Global Const UpdatedMode = "UpdatedMode"
    Global Const UpdatedModePos = 3
    Global Const UpdatedDXCC = "UpdatedDXCC"
    Global Const UpdatedDXCCPos = 4
    Global Const UpdatedProgress = "UpdatedProgress"
    Global Const UpdatedProgressPos = 5
    Global Const UpdatedCQZone = "UpdatedCQZone"
    Global Const UpdatedCQZonePos = 6
    Global Const UpdatedWAZProgress = "UpdatedWAZProgress"
    Global Const UpdatedWAZProgressPos = 7
    Global Const UpdatedWAZBandModeProgress = "UpdatedWAZBandModeProgress"
    Global Const UpdatedWAZBandModeProgressPos = 8
    Global Const UpdatedCountryCode = "UpdatedCountryCode"
    Global Const UpdatedCountryCodePos = 9
    Global Const UpdatedRegion = "UpdatedRegion"
    Global Const UpdatedRegionPos = 10
    Global Const UpdatedIOTAGroup = "UpdatedIOTAGroup"
    Global Const UpdatedIOTAGroupPos = 11
    Global Const UpdatedVUCCGridList = "UpdatedVUCCGridList"
    Global Const UpdatedVUCCGridListPos = 12
    Global Const UpdatedWASState = "UpdatedWASState"
    Global Const UpdatedWASStatePos = 13
    Global Const UpdatedWPXPrefix = "UpdatedWPXPrefix"
    Global Const UpdatedWPXPrefixPos = 14
    Global Const UpdatedIOTAProgress = "UpdatedIOTAProgress"
    Global Const UpdatedIOTAProgressPos = 15
    Global Const UpdatedVUCCProgress = "UpdatedVUCCProgress"
    Global Const UpdatedVUCCProgressPos = 16
    Global Const UpdatedWASStateProgress = "UpdatedWASProgress"
    Global Const UpdatedWASStateProgressPos = 17
    Global Const UpdatedWPXPrefixProgress = "UpdatedWPXProgress"
    Global Const UpdatedWPXPrefixProgressPos = 18

    
Global Const RecomputeProgressCommand = "recomputeprogress"
    Global Const RecomputeFilter = "RecomputeFilter"
    Global Const RecomputeFilterPos = 1
    
Global Const UpdateFilterCommand = "updatefilter"
    Global Const UpdatedFilterName = "filtername"
    Global Const UpdatedFilterNamePos = 1
    Global Const UpdatedFilterValue = "filtervalue"
    Global Const UpdatedFilterValuePos = 2
        
Global Const SpotStationCommand = "spotstation"
    Global Const SpotStationCallsign = "SpotStationCallsign"
    Global Const SpotStationCallsignPos = 1

Global Const ConveySpotCommand = "conveyspot"
    Global Const ConveySpotCallsign = "conveyspotcallsign"
    Global Const ConveySpotCallsignPos = 1
    Global Const ConveySpotFreq = "conveyspotfreq"
    Global Const ConveySpotFreqPos = 2
    Global Const ConveySpotMode = "conveyspotmode"
    Global Const ConveySpotModePos = 3
    Global Const ConveySpotNotes = "conveyspotnotes"
    Global Const ConveySpotNotesPos = 4
    Global Const ConveySpotKind = "conveyspotkind"
    Global Const ConveySpotKindPos = 5
    Global Const ConveySpotSubmode = "conveyspotsubmode"
    Global Const ConveySpotSubmodePos = 6
    
Global Const DisplaySolarHistoryCommand = "displaysolarhistory"

Global Const AnnounceBandCommand = "announceband"
    Global Const AnnounceBandName = "announcebandname"
    Global Const AnnounceBandPos = 1
    
'SpotCollector accepts this command defined in DXView's command section
'Global Const UpdateOverideParamCommand = "updateoverideparam"
'    Global Const UpdateOverideParamIndex = "index"
'    Global Const UpdateOverideParamIndexPos = 1
'    Global Const UpdateOverideParamID = "id"
'    Global Const UpdateOverideParamIDPos = 2
'    Global Const UpdateOverideParamValue = "value"
'    Global Const UpdateOverideParamValuePos = 3

'SpotCollector accepts these commands defined in DXKeeper's command section
'Global Const OpenOverrideDatabaseCommand = "openoverride" '2017-04-15
'Global Const CloseOverrideDatabaseCommand = "closeoverride" '2017-04-15
    
Const EndOfRecord = "<eor>"

Const MaxTokens = 100
    
Type Token
    Name As String
    Content As String
End Type

Dim Tokens As Collection

Dim TokenCount As Integer
Dim TokenArray(1 To MaxTokens) As Token
    
Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long

Function IsRunning(ProgramName As String) As Boolean
    On Error GoTo Abort

    IsRunning = (GetModuleHandle(ProgramName) <> 0)
    Exit Function

Abort: Common.ProgramError Err.Number, "DDECommon.IsRunning"

End Function

Function EncodeField(Name As String, Data As String) As String
    Dim theLength As Integer
    
    On Error GoTo Abort

    If Len(Name) = 0 Then Exit Function
    
    theLength = Len(Data)
    EncodeField = "<" + Name + ":" + Format$(theLength) + ">" + Data
    
    Exit Function

Abort: Common.ProgramError Err.Number, "DDECommon.EncodeField"

End Function

Sub ParseRecord(EncodedData As String)

    Dim FieldDefStart As Integer
    Dim FieldDefEnd As Integer
    Dim FieldDef As String
    Dim FieldNameEnd As Integer
    Dim Fieldname As String
    Dim FieldLength As String
    Dim FieldLengthValue As Integer
    Dim FieldContent As String
        
    Dim theData As String
    
    On Error GoTo Abort

    theData = EncodedData
    TokenCount = 0
    
    While Len(theData) > 0
    
        FieldDefStart = InStr(theData, "<")
        
        If FieldDefStart = 0 Then
            theData = "" 'ignore whatever is left
            
        ElseIf FieldDefStart > 0 Then
            If LCase$(Mid$(theData, FieldDefStart, Len(EndOfRecord))) = EndOfRecord Then
                theData = ""
            End If
            
            FieldDefEnd = InStr(FieldDefStart + 1, theData, ">")
            If FieldDefEnd = 0 Then
                theData = "" 'ignore whatever is left
            
            ElseIf FieldDefEnd > 0 Then
                FieldDef = Mid$(theData, FieldDefStart + 1, FieldDefEnd - FieldDefStart - 1)
                FieldNameEnd = InStr(FieldDef, ":")
                If FieldNameEnd = 0 Then
                    theData = "" 'ignore whatever is left
                
                ElseIf FieldNameEnd > 0 Then
                    Fieldname = Mid$(FieldDef, 1, FieldNameEnd - 1)
                    FieldLength = Mid$(FieldDef, FieldNameEnd + 1, Len(FieldDef) - FieldNameEnd)
                    
                    FieldLengthValue = 0
                    On Error Resume Next
                    FieldLengthValue = CInt(FieldLength)
                    On Error GoTo Abort
                    
                    '2015-11-14 tolerate missing data
                    FieldContent = ""
                    On Error Resume Next
                    FieldContent = Mid$(theData, FieldDefEnd + 1, FieldLengthValue)
                    On Error GoTo Abort
                       
                    
                    TokenCount = TokenCount + 1
                    TokenArray(TokenCount).Name = Fieldname
                    TokenArray(TokenCount).Content = FieldContent
                    
                    '2015-11-14 tolerate missing data
                    On Error Resume Next
                    theData = Mid$(theData, FieldDefEnd + FieldLengthValue + 1, Len(theData) - FieldDefEnd - FieldLengthValue)
                    If Err.Number > 0 Then
                        theData = ""
                    End If
                    On Error GoTo Abort

                End If
            
            End If
        
        End If
        
    Wend

    Exit Sub
    
Abort:
    Common.ProgramError Err.Number, "DDECommon.ParseRecord"
End Sub

Function GetParsedTokenCount() As Integer
    On Error GoTo Abort

    GetParsedTokenCount = TokenCount
    Exit Function

Abort: Common.ProgramError Err.Number, "DDECommon.GetParsedTokenCount"

End Function

Function GetToken(theToken As Integer) As Token
    On Error GoTo Abort

    If theToken > TokenCount Then
        GetToken.Name = ""
        GetToken.Content = ""
    Else
        GetToken = TokenArray(theToken)
    End If
    Exit Function

Abort: Common.ProgramError Err.Number, "DDECommon.GetToken"

End Function

Function ServerName(theServer As Integer) As String
    
    On Error GoTo Abort

    Select Case theServer
    
        Case XcvrControlServer
            ServerName = "XcvrControlServer"
            
        Case LogServer
            ServerName = "LogServer"
            
        Case QSLInfoServer
            ServerName = "QSLInfoServer"
        
        Case DXViewServer
            ServerName = "DXViewServer"
        
        Case SpotServer
            ServerName = "SpotServer"
            
        Case PropServer
            ServerName = "PropagationServer"
            
        Case ModeServer
            ServerName = "ModeServer"
            
        Case Else
            ServerName = ""
    End Select
    
    Exit Function

Abort: Common.ProgramError Err.Number, "DDECommon.ServerName"

End Function

Function ServerNickName(theServer As Integer) As String
    
    On Error GoTo Abort

    Select Case theServer
    
        Case XcvrControlServer
            ServerNickName = "CC"
            
        Case LogServer
            ServerNickName = "DXK"
            
        Case QSLInfoServer
            ServerNickName = "PF"
        
        Case DXViewServer
            ServerNickName = "DXV"
        
        Case SpotServer
            ServerNickName = "SC"
            
        Case PropServer
            ServerNickName = "PV"
            
        Case ModeServer
            ServerNickName = "WW"
            
        Case Else
            ServerNickName = ""
    End Select
    
    Exit Function

Abort: Common.ProgramError Err.Number, "DDECommon.ServerNickName"

End Function

Function ModeName(ModeIndex As Integer) As String
    
    On Error GoTo Abort

    Select Case ModeIndex
    
        Case LSBmode
            ModeName = "LSB"
            
        Case USBMode
            ModeName = "USB"
            
        Case CWMode
            ModeName = "CW"
            
        Case CWRMode
            ModeName = "CW-R"
            
        Case AMMode
            ModeName = "AM"
            
        Case PKTMode
            ModeName = "PKT"
            
        Case PKTRMode
            ModeName = "PKT-R"
            
        Case RTTYMode
            ModeName = "RTTY"
        
        Case RTTYRMode
            ModeName = "RTTY-R"
            
        Case fmMode
            ModeName = "FM"
            
        Case WBFMMode
            ModeName = "WBFM"
            
        Case Else
            ModeName = "?"
    
    End Select
    Exit Function

Abort: Common.ProgramError Err.Number, "DDECommon.ModeName"

End Function

Sub Activate(theForm As Form)

    On Error GoTo Abort
    
    theForm.WindowState = vbNormal
    theForm.ZOrder 0
    
    Exit Sub
    
Abort: Common.ProgramError Err.Number, "DDECommon.Activate"
    
End Sub

Sub Iconify()

    Dim I As Integer
    
    On Error GoTo Abort
    
    For I = 0 To Forms.Count - 1
        Forms(I).WindowState = vbMinimized
    Next I
    
    Exit Sub
    
Abort: Common.ProgramError Err.Number, "DDECommon.Iconify"

End Sub

Function StripTrailingCRLF(theData As String) As String
    
    On Error GoTo Abort
    
    If Len(theData) > 2 Then
        If Asc(Mid$(theData, Len(theData) - 1, 1)) = 13 Then
            If Asc(Mid$(theData, Len(theData), 1)) = 10 Then
                StripTrailingCRLF = Mid$(theData, 1, Len(theData) - 2)
                Exit Function
            End If
        End If
    End If
    StripTrailingCRLF = theData

    Exit Function
    
    
Abort: Common.ProgramError Err.Number, "DDECommon.StripTrailingCRLF"
    StripTrailingCRLF = theData
End Function
