Attribute VB_Name = "DXLabControlModule"
Option Explicit

Const FirstModeIndex = 0
Const LastModeIndex = 9

Dim LogRecord As String

Sub InitializeModeCombo()

    DXLabControlMain.ModeCombo.AddItem "SSB"
    DXLabControlMain.ModeCombo.AddItem "CW"
    DXLabControlMain.ModeCombo.AddItem "RTTY"
    DXLabControlMain.ModeCombo.AddItem "AM"
    DXLabControlMain.ModeCombo.AddItem "FM"
            
End Sub

Sub InitializeFilterCombo()

    DXLabControlMain.FilterCombo.AddItem ""
    DXLabControlMain.FilterCombo.AddItem "wide"
    DXLabControlMain.FilterCombo.AddItem "narrow"
    DXLabControlMain.FilterCombo.AddItem "normal"
            
End Sub

Sub InitializeQTHAreaCombo()
    DXLabControlMain.QTHAreaCombo.AddItem ""
    DXLabControlMain.QTHAreaCombo.AddItem "NAE"
    DXLabControlMain.QTHAreaCombo.AddItem "NAM"
    DXLabControlMain.QTHAreaCombo.AddItem "NAW"
    DXLabControlMain.QTHAreaCombo.AddItem "EU"
    DXLabControlMain.QTHAreaCombo.AddItem "AS"
    DXLabControlMain.QTHAreaCombo.AddItem "OC"
    DXLabControlMain.QTHAreaCombo.AddItem "AF"
    DXLabControlMain.QTHAreaCombo.AddItem "SA"
    
End Sub

Function GetBandForFrequency(Frequency As String) As String
    Dim theFreq As Double
    
    GetBandForFrequency = ""
    
    On Error GoTo BadFreq
    
    theFreq = CDbl(Frequency)
    
    If (theFreq >= 1800) And (theFreq <= 2000) Then
        GetBandForFrequency = "160M"
    ElseIf (theFreq >= 3500) And (theFreq <= 4000) Then
        GetBandForFrequency = "80M"
    ElseIf (theFreq >= 7000) And (theFreq <= 7300) Then
        GetBandForFrequency = "40M"
    ElseIf (theFreq >= 10100) And (theFreq <= 10150) Then
        GetBandForFrequency = "30M"
    ElseIf (theFreq >= 14000) And (theFreq <= 14350) Then
        GetBandForFrequency = "20M"
    ElseIf (theFreq >= 18068) And (theFreq <= 18168) Then
        GetBandForFrequency = "17M"
    ElseIf (theFreq >= 21000) And (theFreq <= 21450) Then
        GetBandForFrequency = "15M"
    ElseIf (theFreq >= 24890) And (theFreq <= 24990) Then
        GetBandForFrequency = "12M"
    ElseIf (theFreq >= 28000) And (theFreq <= 29700) Then
        GetBandForFrequency = "10M"
    ElseIf (theFreq >= 50000) And (theFreq <= 54000) Then
        GetBandForFrequency = "6M"
    ElseIf (theFreq >= 144000) And (theFreq <= 148000) Then
        GetBandForFrequency = "2M"
    End If
    
    Exit Function
    
BadFreq:

End Function

Function RemoveLeadingAngleBrackets(theData) As String
    Dim I As Integer
    Dim theChar As String
    Dim Result As String
    
    Result = ""
    For I = 1 To Len(theData)
        theChar = Mid$(theData, I, 1)
        If theChar <> "<" Then
            Result = Result + theChar
        End If
    Next I
    RemoveLeadingAngleBrackets = Result
    
End Function

Sub ClearLogRecord()
    LogRecord = ""
End Sub

Function GetLogRecord()
    GetLogRecord = LogRecord
End Function

Sub AppendField(Fieldname As String, theData As String)
    Dim theCleanData As String
    
    theCleanData = DXLabControlModule.RemoveLeadingAngleBrackets(theData)
    If Len(theCleanData) = 0 Then Exit Sub
    
    LogRecord = LogRecord + "<" + Fieldname + ":" + Format$(Len(theCleanData)) + ">" + theCleanData + " "
    Exit Sub
   
End Sub

Sub InitializeSpotModeCombo()
    
    DXLabControlMain.SpotModeCombo.AddItem ""
    DXLabControlMain.SpotModeCombo.AddItem "AM"
    DXLabControlMain.SpotModeCombo.AddItem "CW"
    DXLabControlMain.SpotModeCombo.AddItem "FM"
    DXLabControlMain.SpotModeCombo.AddItem "PSK"
    DXLabControlMain.SpotModeCombo.AddItem "PSK63"
    DXLabControlMain.SpotModeCombo.AddItem "RTTY"
    DXLabControlMain.SpotModeCombo.AddItem "SSB"
            
End Sub



