Attribute VB_Name = "LocaleInfo"
Option Explicit

    Private Const LOCALE_USER_DEFAULT& = &H400
    
    Private Const LOCALE_ILANGUAGE = &H1         '  language id
    Private Const LOCALE_SLANGUAGE = &H2         '  localized name of language
    Private Const LOCALE_SENGLANGUAGE = &H1001      '  English name of language
    Private Const LOCALE_SABBREVLANGNAME = &H3         '  abbreviated language name
    Private Const LOCALE_SNATIVELANGNAME = &H4         '  native name of language
    Private Const LOCALE_ICOUNTRY = &H5         '  country code
    Private Const LOCALE_SCOUNTRY = &H6         '  localized name of country
    Private Const LOCALE_SENGCOUNTRY = &H1002      '  English name of country
    Private Const LOCALE_SABBREVCTRYNAME = &H7         '  abbreviated country name
    Private Const LOCALE_SNATIVECTRYNAME = &H8         '  native name of country
    Private Const LOCALE_IDEFAULTLANGUAGE = &H9         '  default language id
    Private Const LOCALE_IDEFAULTCOUNTRY = &HA         '  default country code
    Private Const LOCALE_IDEFAULTCODEPAGE = &HB         '  default OEM code page
    Private Const LOCALE_LOCALE_IDEFAULTANSICODEPAGE = &H1004         '  default ANSI code page
    
    Private Const LOCALE_SLIST = &HC         '  list item separator
    Private Const LOCALE_IMEASURE = &HD         '  0 = metric, 1 = US

    Private Const LOCALE_SDECIMAL = &HE         '  decimal separator
    Private Const LOCALE_STHOUSAND = &HF         '  thousand separator
    Private Const LOCALE_SGROUPING = &H10        '  digit grouping
    Private Const LOCALE_IDIGITS = &H11        '  number of fractional digits
    Private Const LOCALE_ILZERO = &H12        '  leading zeros for decimal
    Private Const LOCALE_SNATIVEDIGITS = &H13        '  native ascii 0-9

    Private Const LOCALE_SCURRENCY = &H14        '  local monetary symbol
    Private Const LOCALE_SINTLSYMBOL = &H15        '  intl monetary symbol
    Private Const LOCALE_SMONDECIMALSEP = &H16        '  monetary decimal separator
    Private Const LOCALE_SMONTHOUSANDSEP = &H17        '  monetary thousand separator
    Private Const LOCALE_SMONGROUPING = &H18        '  monetary grouping
    Private Const LOCALE_ICURRDIGITS = &H19        '  # local monetary digits
    Private Const LOCALE_IINTLCURRDIGITS = &H1A        '  # intl monetary digits
    Private Const LOCALE_ICURRENCY = &H1B        '  positive currency mode
    Private Const LOCALE_INEGCURR = &H1C        '  negative currency mode

    Private Const LOCALE_SDATE = &H1D        '  date separator
    Private Const LOCALE_STIME = &H1E        '  time separator
    Private Const LOCALE_SSHORTDATE = &H1F        '  short date format string
    Private Const LOCALE_SLONGDATE = &H20        '  long date format string
    Private Const LOCALE_STIMEFORMAT = &H1003      '  time format string
    Private Const LOCALE_IDATE = &H21        '  short date format ordering
    Private Const LOCALE_ILDATE = &H22        '  long date format ordering
    Private Const LOCALE_ITIME = &H23        '  time format specifier
    Private Const LOCALE_ICENTURY = &H24        '  century format specifier
    Private Const LOCALE_ITLZERO = &H25        '  leading zeros in time field
    Private Const LOCALE_IDAYLZERO = &H26        '  leading zeros in day field
    Private Const LOCALE_IMONLZERO = &H27        '  leading zeros in month field
    Private Const LOCALE_S1159 = &H28        '  AM designator
    Private Const LOCALE_S2359 = &H29        '  PM designator

    Private Const LOCALE_SDAYNAME1 = &H2A        '  long name for Monday
    Private Const LOCALE_SDAYNAME2 = &H2B        '  long name for Tuesday
    Private Const LOCALE_SDAYNAME3 = &H2C        '  long name for Wednesday
    Private Const LOCALE_SDAYNAME4 = &H2D        '  long name for Thursday
    Private Const LOCALE_SDAYNAME5 = &H2E        '  long name for Friday
    Private Const LOCALE_SDAYNAME6 = &H2F        '  long name for Saturday
    Private Const LOCALE_SDAYNAME7 = &H30        '  long name for Sunday
    Private Const LOCALE_SABBREVDAYNAME1 = &H31        '  abbreviated name for Monday
    Private Const LOCALE_SABBREVDAYNAME2 = &H32        '  abbreviated name for Tuesday
    Private Const LOCALE_SABBREVDAYNAME3 = &H33        '  abbreviated name for Wednesday
    Private Const LOCALE_SABBREVDAYNAME4 = &H34        '  abbreviated name for Thursday
    Private Const LOCALE_SABBREVDAYNAME5 = &H35        '  abbreviated name for Friday
    Private Const LOCALE_SABBREVDAYNAME6 = &H36        '  abbreviated name for Saturday
    Private Const LOCALE_SABBREVDAYNAME7 = &H37        '  abbreviated name for Sunday
    Private Const LOCALE_SMONTHNAME1 = &H38        '  long name for January
    Private Const LOCALE_SMONTHNAME2 = &H39        '  long name for February
    Private Const LOCALE_SMONTHNAME3 = &H3A        '  long name for March
    Private Const LOCALE_SMONTHNAME4 = &H3B        '  long name for April
    Private Const LOCALE_SMONTHNAME5 = &H3C        '  long name for May
    Private Const LOCALE_SMONTHNAME6 = &H3D        '  long name for June
    Private Const LOCALE_SMONTHNAME7 = &H3E        '  long name for July
    Private Const LOCALE_SMONTHNAME8 = &H3F        '  long name for August
    Private Const LOCALE_SMONTHNAME9 = &H40        '  long name for September
    Private Const LOCALE_SMONTHNAME10 = &H41        '  long name for October
    Private Const LOCALE_SMONTHNAME11 = &H42        '  long name for November
    Private Const LOCALE_SMONTHNAME12 = &H43        '  long name for December
    Private Const LOCALE_SABBREVMONTHNAME1 = &H44        '  abbreviated name for January
    Private Const LOCALE_SABBREVMONTHNAME2 = &H45        '  abbreviated name for February
    Private Const LOCALE_SABBREVMONTHNAME3 = &H46        '  abbreviated name for March
    Private Const LOCALE_SABBREVMONTHNAME4 = &H47        '  abbreviated name for April
    Private Const LOCALE_SABBREVMONTHNAME5 = &H48        '  abbreviated name for May
    Private Const LOCALE_SABBREVMONTHNAME6 = &H49        '  abbreviated name for June
    Private Const LOCALE_SABBREVMONTHNAME7 = &H4A        '  abbreviated name for July
    Private Const LOCALE_SABBREVMONTHNAME8 = &H4B        '  abbreviated name for August
    Private Const LOCALE_SABBREVMONTHNAME9 = &H4C        '  abbreviated name for September
    Private Const LOCALE_SABBREVMONTHNAME10 = &H4D        '  abbreviated name for October
    Private Const LOCALE_SABBREVMONTHNAME11 = &H4E        '  abbreviated name for November
    Private Const LOCALE_SABBREVMONTHNAME12 = &H4F        '  abbreviated name for December
    Private Const LOCALE_SABBREVMONTHNAME13 = &H100F

    Private Const LOCALE_SPOSITIVESIGN = &H50        '  positive sign
    Private Const LOCALE_SNEGATIVESIGN = &H51        '  negative sign
    Private Const LOCALE_IPOSSIGNPOSN = &H52        '  positive sign position
    Private Const LOCALE_INEGSIGNPOSN = &H53        '  negative sign position
    Private Const LOCALE_IPOSSYMPRECEDES = &H54        '  mon sym precedes pos amt
    Private Const LOCALE_IPOSSEPBYSPACE = &H55        '  mon sym sep by space from pos amt
    Private Const LOCALE_INEGSYMPRECEDES = &H56        '  mon sym precedes neg amt
    Private Const LOCALE_INEGSEPBYSPACE = &H57        '  mon sym sep by space from neg amt

    Private Const LOCALE_NOUSEROVERRIDE = &H80000000  '  do not use user overrides
    
    Public Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long
    Public Declare Function GetUserDefaultLCID Lib "kernel32" () As Long
    Private Declare Function GetLocaleInfo& Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long)
        
    Dim LocaleThousandSeparator As String
    Dim LocaleDecimalSeparator As String
    
    Dim LocaleDateSeparator As String
    Dim LocaleTimeSeparator As String
    
    Dim LocaleANSICodePage As String
    
    Dim MonthAbbrev(12) As String
    
    Dim LCID As Long
    
   
    Public Function LPSTRToVBString$(ByVal s$)
    Dim nullpos&
    On Error GoTo Abort

    nullpos& = InStr(s$, Chr$(0))
    
    
    If nullpos > 0 Then
        LPSTRToVBString = Left$(s$, nullpos - 1)
    Else
        LPSTRToVBString = ""
    End If
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.LPSTRToVBString$"

    End Function

Sub Initialize()
    On Error GoTo Abort

    LCID = GetUserDefaultLCID()
    
    LocaleInfo.GetLocaleSeparators

    Common.DebugLog "LocaleInfo.Initialize: decimal symbol       : " + LocaleThousandSeparator + " [ascii " + Format$(Asc(LocaleThousandSeparator)) + "]"
    Common.DebugLog "LocaleInfo.Initialize: digit grouping symbol: " + LocaleDecimalSeparator + " [ascii " + Format$(Asc(LocaleDecimalSeparator)) + "]"
    Common.DebugLog "LocaleInfo.Initialize: date separator       : " + LocaleDateSeparator + " [ascii " + Format$(Asc(LocaleDateSeparator)) + "]"
    Common.DebugLog "LocaleInfo.Initialize: time separator       : " + LocaleTimeSeparator + " [ascii " + Format$(Asc(LocaleTimeSeparator)) + "]"
    
    If LocaleThousandSeparator = LocaleDecimalSeparator Then
        MsgBox "Your PC's regional options are incorrectly configured: its 'digit grouping symbol' and 'decimal symbol' are identical. This may prevent correct operation of " + App.ProductName + "; you can rectify this via the Windows Control panel's Regional Options applet", vbOKOnly, App.ProductName
    End If
    
    LocaleInfo.GetMonthAbbreviations
    
    LocaleANSICodePage = "?"
    If LCID <> 0 Then
        LocaleANSICodePage = GetUserLocaleInfo(LCID, LOCALE_LOCALE_IDEFAULTANSICODEPAGE)
    End If
    
    Exit Sub

Abort: Common.ProgramError Err.Number, "LocaleInfo.Initialize"

End Sub

Sub Display()
    On Error GoTo Abort
    
    Common.DebugLog "LocaleInfo.Display: decimal symbol       : " + LocaleThousandSeparator + " [ascii " + Format$(Asc(LocaleThousandSeparator)) + "]"
    Common.DebugLog "LocaleInfo.Display: digit grouping symbol: " + LocaleDecimalSeparator + " [ascii " + Format$(Asc(LocaleDecimalSeparator)) + "]"
    Common.DebugLog "LocaleInfo.Display: date separator       : " + LocaleDateSeparator + " [ascii " + Format$(Asc(LocaleDateSeparator)) + "]"
    Common.DebugLog "LocaleInfo.Display: time separator       : " + LocaleTimeSeparator + " [ascii " + Format$(Asc(LocaleTimeSeparator)) + "]"
    Exit Sub

Abort: Common.ProgramError Err.Number, "LocaleInfo.Display"
End Sub

Function GetLocaleID() As Long
    On Error GoTo Abort
    GetLocaleID = LCID
    Exit Function
    
Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleID"
End Function

Function GetLocaleLanguage() As String
   
    On Error GoTo Abort
   
    GetLocaleLanguage = "?"
    If LCID <> 0 Then
        GetLocaleLanguage = GetUserLocaleInfo(LCID, LOCALE_SENGLANGUAGE)
    End If
        
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleLanguage"

End Function

Function GetLocaleOEMCodePage() As String
   
    On Error GoTo Abort
   
    GetLocaleOEMCodePage = "?"
    If LCID <> 0 Then
        GetLocaleOEMCodePage = GetUserLocaleInfo(LCID, LOCALE_IDEFAULTCODEPAGE)
    End If
        
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleOEMCodePage"

End Function

Function GetLocaleANSICodePage() As String
   
    On Error GoTo Abort
   
    GetLocaleANSICodePage = LocaleANSICodePage
        
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleANSICodePage"

End Function

Function GetLocaleCountry() As String
   
    On Error GoTo Abort

    GetLocaleCountry = "?"
    If LCID <> 0 Then
        GetLocaleCountry = GetUserLocaleInfo(LCID, LOCALE_SENGCOUNTRY)
    End If
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleCountry"

End Function

Function GetUserLocaleInfo(ByVal dwLocaleID As Long, ByVal dwLCType As Long) As String

   Dim sReturn As String
   Dim r As Long

    On Error GoTo Abort

  'call the function passing the Locale type
  'variable to retrieve the required size of
  'the string buffer needed
   r = GetLocaleInfo(dwLocaleID, dwLCType, sReturn, Len(sReturn))

  'if successful..
   If r Then

     'pad the buffer with r spaces
      sReturn = Space$(r)

     'and call again passing the buffer
      r = GetLocaleInfo(dwLocaleID, dwLCType, sReturn, Len(sReturn))

     'if successful (r > 0)
      If r Then

        'r holds the size of the string
        'including the terminating null
         GetUserLocaleInfo = Left$(sReturn, r - 1)

      End If

   End If

    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetUserLocaleInfo"

End Function

Sub GetLocaleSeparators()
    Dim r As Long, s As String
    On Error GoTo Abort

    s = String(10, "a")
    r = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_STHOUSAND, s, 10)
    LocaleThousandSeparator = Mid$(s, 1, 1)
    
    s = String(10, "a")
    r = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SDECIMAL, s, 10)
    LocaleDecimalSeparator = Mid$(s, 1, 1)
    
    s = String(10, "a")
    r = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SDATE, s, 10)
    LocaleDateSeparator = Mid$(s, 1, 1)
    
    s = String(10, "a")
    r = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_STIME, s, 10)
    LocaleTimeSeparator = Mid$(s, 1, 1)
    
    Exit Sub

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleSeparators"

End Sub

Function GetLocaleThousandSeparator() As String
    On Error GoTo Abort

    GetLocaleThousandSeparator = LocaleThousandSeparator
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleThousandSeparator"

End Function

Function GetLocaleDecimalSeparator() As String
    On Error GoTo Abort

    GetLocaleDecimalSeparator = LocaleDecimalSeparator
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleDecimalSeparator"

End Function


Function GetLocaleDateSeparator() As String
    On Error GoTo Abort

    GetLocaleDateSeparator = LocaleDateSeparator
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleDateSeparator"

End Function

Function GetLocaleTimeSeparator() As String
    On Error GoTo Abort

    GetLocaleTimeSeparator = LocaleTimeSeparator
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetLocaleTimeSeparator"

End Function



Sub GetMonthAbbreviations()
    Dim r As Long
    Dim s As String
    Dim I As Integer
    Dim Code As Long
    
    On Error GoTo Abort

    Code = LOCALE_SABBREVMONTHNAME1
    
    For I = 1 To 12
        s = String(10, "a")
        MonthAbbrev(I) = "???"
        r = GetLocaleInfo(LOCALE_USER_DEFAULT, Code, s, 10)
        If r > 0 Then
            MonthAbbrev(I) = Mid$(s, 1, r - 1)
        End If
        Code = Code + 1
    Next I
    Exit Sub

Abort: Common.ProgramError Err.Number, "LocaleInfo.GetMonthAbbreviations"

End Sub

Function MonthAbbreviation(MonthIndex As Integer)
    On Error GoTo Abort

    MonthAbbreviation = MonthAbbrev(MonthIndex)
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.MonthAbbreviation"

End Function

Function ConvertLocaleNumericString(theSource As String) As String

    'convert standard string (comma is thousands separator, period is decimal separator) to a string using the locale-specific characters
    Dim I As Integer
    Dim theResult As String
    Dim theChar As String
    
    On Error GoTo Abort

    If (LocaleThousandSeparator <> ",") Or (LocaleDecimalSeparator <> ".") Then
    
        theResult = ""
        For I = 1 To Len(theSource)
            theChar = Mid$(theSource, I, 1)
            If theChar = "," Then
                theResult = theResult + LocaleThousandSeparator
            ElseIf theChar = "." Then
                theResult = theResult + LocaleDecimalSeparator
            Else
                theResult = theResult + theChar
            End If
        Next I
        
        ConvertLocaleNumericString = theResult
    
    Else
    
        ConvertLocaleNumericString = theSource
        
    End If
        
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.ConvertLocaleNumericString"

End Function

Function ConvertStandardNumericString(theSource As String) As String

    'convert locale string to standard string (comma is thousands separator, period is decimal separator)
    Dim I As Integer
    Dim theResult As String
    Dim theChar As String
    
    On Error GoTo Abort
   
    theResult = ""
    For I = 1 To Len(theSource)
        theChar = Mid$(theSource, I, 1)
        If theChar = LocaleThousandSeparator Then
            theResult = theResult + ","
        ElseIf theChar = LocaleDecimalSeparator Then
            theResult = theResult + "."
        Else
            theResult = theResult + theChar
        End If
    Next I
    
    ConvertStandardNumericString = theResult
        
    Exit Function

Abort: Common.ProgramError Err.Number, "LocaleInfo.ConvertStandardNumericString"

End Function

Function ConvertUSDateString(theUSDate As String) As String

    'input: US date string in DD-MMM-YYYY format
    'output: if input is valid, ISO date string: YYYY-MM-DD, else ""
    
    Dim Sep1 As Integer
    Dim Sep2 As Integer
    
    Dim theDate As String
    Dim theDay As String
    Dim theMonth As String
    Dim theYear As String
    
    Dim theDayInt As Integer
    Dim theMonthInt As Integer
    Dim theYearInt As Integer
    
    Dim I As Integer
    
    On Error GoTo Abort
    
    Common.DebugLog "LocaleInfo.ConvertUSDateString: theUSDate = " + theUSDate
    
    theDate = Trim$(theUSDate)
    
    ConvertUSDateString = ""
    
    Sep1 = InStr(theDate, "-")
    Sep2 = InStr(Sep1 + 1, theDate, "-")
    
    If (Sep1 = 0) Or (Sep2) = 0 Then Exit Function
    
    theDay = ""
    theMonth = ""
    theYear = ""
    
    On Error Resume Next
    theDay = Mid$(theDate, 1, Sep1 - 1)
    theMonth = UCase$(Mid$(theDate, Sep1 + 1, Sep2 - Sep1 - 1))
    theYear = Mid$(theDate, Sep2 + 1, Len(theDate) - Sep2)
    On Error GoTo Abort
    
    If (Len(theDay) = 0) Or (Len(theMonth) = 0) Or (Len(theYear) = 0) Then Exit Function
    
    theDayInt = 0
    theYearInt = 0
    
    On Error GoTo Abort
    theDayInt = CInt(theDay)
    theYearInt = CInt(theYear)
    On Error GoTo Abort
    
    If (theDayInt = 0) Or (theYearInt = 0) Then Exit Function
    
    For I = 1 To 12
        If theMonth = UCase$(Common.MonthName(I)) Then
            ConvertUSDateString = Format$(theYearInt, "0000") + "-" + Format$(I, "00") + "-" + Format$(theDayInt, "00")
             Common.DebugLog "   result = " + ConvertUSDateString
            Exit Function
        End If
    Next I
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "LocaleInfo.ConvertUSDateString"

End Function
