Attribute VB_Name = "UTC"
Option Explicit

Const DaySeconds As Double = 24# * 3600#
Const HourSeconds As Double = 3600#

Private Type systemtime
       wYear As Integer
       wMonth As Integer
       wDayOfWeek As Integer
       wDay As Integer
       wHour As Integer
       wMinute As Integer
       wSecond As Integer
       wMilliseconds As Integer
End Type

Private Declare Sub GetSystemTime Lib "kernel32" (lpSystemTime As systemtime)

Function CurrentTime() As Date
    Dim UTCTime As systemtime
    Dim TimeString As String
    
    Dim Days As Double
    Dim Seconds As Double
    Dim I As Integer
    
    Dim State As Integer
    
    On Error GoTo Abort

    State = 0
    
    Call GetSystemTime(UTCTime)
    
    State = 1

    Days = 36525 'days from 12/30/1899 to 12/31/1999
    
    For I = 2000 To (UTCTime.wYear - 1)
        If (I Mod 400 = 0) Or ((I Mod 100 <> 0) And (I Mod 4 = 0)) Then
            Days = Days + 366
        Else
            Days = Days + 365
        End If
    Next I
    
    State = 2
    
    For I = 1 To UTCTime.wMonth
        Days = Days + MonthDays(I, (UTCTime.wYear Mod 400 = 0) Or ((UTCTime.wYear Mod 100 <> 0) And (UTCTime.wYear Mod 4 = 0)))
    Next I
    
    State = 3
    
    Days = Days + UTCTime.wDay

    State = 4
    
    Seconds = (UTCTime.wHour * HourSeconds) + (UTCTime.wMinute * 60) + UTCTime.wSecond
    
    State = 5
    
    CurrentTime = CDate(Days + (Seconds / DaySeconds))
    
    Exit Function

Abort:

    Common.ProgramError Err.Number, "UTC.CurrentTime, State = " + Format$(State)
    
    Common.Log "   UTCTime.wYear   = " + Format$(UTCTime.wYear)
    Common.Log "   UTCTime.wMonth  = " + Format$(UTCTime.wMonth)
    Common.Log "   UTCTime.wDay    = " + Format$(UTCTime.wDay)
    Common.Log "   UTCTime.wHour   = " + Format$(UTCTime.wHour)
    Common.Log "   UTCTime.wMinute = " + Format$(UTCTime.wMinute)
    Common.Log "   UTCTime.wSecond = " + Format$(UTCTime.wSecond)
    
End Function

Function MonthDays(Index As Integer, LeapYear As Boolean) As Integer
    On Error GoTo Abort

    Select Case Index
        Case 1
            MonthDays = 0
        Case 2
            MonthDays = 31 'Jan
        Case 3
            If LeapYear Then
                MonthDays = 29 'Feb
            Else
                MonthDays = 28 'Feb
            End If
        Case 4
            MonthDays = 31 'March
        Case 5
            MonthDays = 30 'April
        Case 6
            MonthDays = 31 'May
        Case 7
            MonthDays = 30 'June
        Case 8
            MonthDays = 31 'July
        Case 9
            MonthDays = 31 'August
        Case 10
            MonthDays = 30 'September
        Case 11
            MonthDays = 31 'October
        Case 12
            MonthDays = 30 'November
        End Select
        
    Exit Function

Abort: Common.ProgramError Err.Number, "UTC.MonthDays"

End Function

Function MonthName(Index As Integer) As String
    On Error GoTo Abort

    Select Case Index
        Case 1
            MonthName = "Jan"
        Case 2
            MonthName = "Feb"
        Case 3
            MonthName = "Mar"
        Case 4
            MonthName = "Apr"
        Case 5
            MonthName = "May"
        Case 6
            MonthName = "Jun"
        Case 7
            MonthName = "Jul"
        Case 8
            MonthName = "Aug"
        Case 9
            MonthName = "Sep"
        Case 10
            MonthName = "Oct"
        Case 11
            MonthName = "Nov"
        Case 12
            MonthName = "Dec"
        End Select
    Exit Function

Abort: Common.ProgramError Err.Number, "UTC.MonthName"

End Function
